
function setPresentAbsentLogic(presentLevel,absentLevel) {
	lInfo.logln('setPresentAbsentLogic');
	Property.setProperty('apartmentVentilation/logic/absent/triggers/1/type','zone-scene');
	Property.setProperty('apartmentVentilation/logic/absent/triggers/1/zone',0);
	Property.setProperty('apartmentVentilation/logic/absent/triggers/1/group',0);
	Property.setProperty('apartmentVentilation/logic/absent/triggers/1/scene',72);
	Property.setProperty('apartmentVentilation/logic/absent/triggers/1/dsuid',-1);
	Property.setProperty('apartmentVentilation/logic/absent/actions/1/type','zone-scene');
	Property.setProperty('apartmentVentilation/logic/absent/actions/1/zone',0);
	Property.setProperty('apartmentVentilation/logic/absent/actions/1/group',64);
	Property.setProperty('apartmentVentilation/logic/absent/actions/1/scene',absentLevel);
	registerTrigger('/scripts/heating-controller/apartmentVentilation/logic/absent','action_execute',{});

	Property.setProperty('apartmentVentilation/logic/present/triggers/1/type','zone-scene');
	Property.setProperty('apartmentVentilation/logic/present/triggers/1/zone',0);
	Property.setProperty('apartmentVentilation/logic/present/triggers/1/group',0);
	Property.setProperty('apartmentVentilation/logic/present/triggers/1/scene',71);
	Property.setProperty('apartmentVentilation/logic/present/triggers/1/dsuid',-1);
	Property.setProperty('apartmentVentilation/logic/present/actions/1/type','zone-scene');
	Property.setProperty('apartmentVentilation/logic/present/actions/1/zone',0);
	Property.setProperty('apartmentVentilation/logic/present/actions/1/group',64);
	Property.setProperty('apartmentVentilation/logic/present/actions/1/scene',presentLevel);
	registerTrigger('/scripts/heating-controller/apartmentVentilation/logic/present','action_execute',{});
	lInfo.logln('setPresentAbsentLogic done');
}

function removeBoostState() {
	lInfo.logln('removeBoostState');
	if (Property.getNode('apartmentVentilation/logic/boostState')!=null) {
		lInfo.logln('removeBoostState - removing things');
		unregisterTrigger('/scripts/heating-controller/apartmentVentilation/logic/boostState');
		Property.getNode('apartmentVentilation/logic').removeChild('boostState');
		unregisterTrigger('/scripts/heating-controller/apartmentVentilation/logic/boostStateDeact');
		Property.getNode('apartmentVentilation/logic').removeChild('boostStateDeact');
	}	
	lInfo.logln('removeBoostState done');
}
function setBoostState() {
	lInfo.logln('setBoostState');

	var allLevels=[0,5,17,18,19];
	Property.setProperty('apartmentVentilation/logic/boostState/triggers/1/type','zone-scene');
	Property.setProperty('apartmentVentilation/logic/boostState/triggers/1/zone',0);
	Property.setProperty('apartmentVentilation/logic/boostState/triggers/1/group',64);
	Property.setProperty('apartmentVentilation/logic/boostState/triggers/1/scene',36);
	Property.setProperty('apartmentVentilation/logic/boostState/triggers/1/dsuid',-1);
	Property.setProperty('apartmentVentilation/logic/boostState/actions/1/type','change-addon-state');
	Property.setProperty('apartmentVentilation/logic/boostState/actions/1/statename','apartmentVentilationBoost');
	Property.setProperty('apartmentVentilation/logic/boostState/actions/1/state','active');
	Property.setProperty('apartmentVentilation/logic/boostState/actions/1/addon-id','heating-controller');
	registerTrigger('/scripts/heating-controller/apartmentVentilation/logic/boostState','action_execute',{});

	for (var iIndex=0;iIndex<allLevels.length;iIndex++) {
		if (allLevels[iIndex]!=36) {
			Property.setProperty('apartmentVentilation/logic/boostStateDeact/triggers/'+iIndex+'/type','zone-scene');
			Property.setProperty('apartmentVentilation/logic/boostStateDeact/triggers/'+iIndex+'/zone',0);
			Property.setProperty('apartmentVentilation/logic/boostStateDeact/triggers/'+iIndex+'/group',64);
			Property.setProperty('apartmentVentilation/logic/boostStateDeact/triggers/'+iIndex+'/scene',allLevels[iIndex]);
			Property.setProperty('apartmentVentilation/logic/boostStateDeact/triggers/'+iIndex+'/dsuid',-1);
		}
	}
	
	Property.setProperty('apartmentVentilation/logic/boostStateDeact/actions/1/type','change-addon-state');
	Property.setProperty('apartmentVentilation/logic/boostStateDeact/actions/1/statename','apartmentVentilationBoost');
	Property.setProperty('apartmentVentilation/logic/boostStateDeact/actions/1/state','inactive');
	Property.setProperty('apartmentVentilation/logic/boostStateDeact/actions/1/addon-id','heating-controller');
	registerTrigger('/scripts/heating-controller/apartmentVentilation/logic/boostStateDeact','action_execute',{});
	lInfo.logln('setBoostState done');
}

function removeSensoricBoost() {
	lInfo.logln('removeSensoricBoost');
	if (Property.getNode('apartmentVentilation/logic/boostSensoricOn')!=null) {
		lInfo.logln('removeSensoricBoost - removing');		
		try {
		var oArray=Property.getNode('apartmentVentilation/logic/boostSensoricOn/triggers').getChildren();
		for (var iIndex=0;iIndex<oArray.length;iIndex++) {
			var stateName=oArray[iIndex].getChild('name').getValue();
			lInfo.logln('setBoostState - removing ' + stateName);
			unregisterStateSensor(stateName);
		}
				
		unregisterTrigger(Property.getNode('apartmentVentilation/logic/boostSensoricOn').getPath());
		unregisterTrigger(Property.getNode('apartmentVentilation/logic/boostSensoricOff').getPath());
		Property.getNode('apartmentVentilation/logic').removeChild('boostSensoricOn');
		Property.getNode('apartmentVentilation/logic').removeChild('boostSensoricOff');
		} catch (e) {}
	}	
	lInfo.logln('removeSensoricBoost done');
}

function setSensoricBoost(sensorLevel,nominalLevel,boostTimeout) {
	lInfo.logln('setSensoricBoost');
	
	var sSensorState=[];
	var oZoneArray=Property.getNode('/apartment/zones').getChildren();
	for (var iIndex=0;iIndex<oZoneArray.length;iIndex++) {
		var zoneNode=oZoneArray[iIndex];
		if (zoneNode.getChild('ZoneID').getValue()!=0) {
			var zoneID=zoneNode.getChild('ZoneID').getValue();
			lInfo.logln('setSensoricBoost - zoneID ' + zoneID);
			if (zoneNode.getChild('groups/group0/sensor/type13')!=null) {	
				lInfo.logln('setSensoricBoost - found sensor');
				var oZone=getZoneByID(zoneID);
				lInfo.logln('setSensoricBoost - found zone');
				var stateName=oZone.addStateSensor(0,13,"> ; " + sensorLevel,"< ; " + sensorLevel,"heating-controller-apartment-ventilation");
				lInfo.logln('setSensoricBoost - sensorState ' + stateName);
				sSensorState.push(stateName);
				Property.setProperty('apartmentVentilation/logic/boostSensoricOn/triggers/'+zoneID+'/type','state-change');
				Property.setProperty('apartmentVentilation/logic/boostSensoricOn/triggers/'+zoneID+'/name',stateName);
				Property.setProperty('apartmentVentilation/logic/boostSensoricOn/triggers/'+zoneID+'/state','active');

				Property.setProperty('apartmentVentilation/logic/boostSensoricOff/triggers/'+zoneID+'/type','state-change');
				Property.setProperty('apartmentVentilation/logic/boostSensoricOff/triggers/'+zoneID+'/name',stateName);
				Property.setProperty('apartmentVentilation/logic/boostSensoricOff/triggers/'+zoneID+'/state','inactive');

				Property.setProperty('apartmentVentilation/logic/boostSensoricOff/conditions/addon-states/heating-controller/'+stateName,2);				

			}
		}
	}
	Property.setProperty('apartmentVentilation/logic/boostSensoricOn/actions/1/type','zone-scene');
	Property.setProperty('apartmentVentilation/logic/boostSensoricOn/actions/1/zone',0);
	Property.setProperty('apartmentVentilation/logic/boostSensoricOn/actions/1/group',64);
	Property.setProperty('apartmentVentilation/logic/boostSensoricOn/actions/1/delay',0);
	Property.setProperty('apartmentVentilation/logic/boostSensoricOn/actions/1/scene',36);
	Property.setProperty('apartmentVentilation/logic/boostSensoricOn/actions/2/type','change-addon-state');
	Property.setProperty('apartmentVentilation/logic/boostSensoricOn/actions/2/statename','apartmentVentilationBoost');
	Property.setProperty('apartmentVentilation/logic/boostSensoricOn/actions/2/state','active');
	Property.setProperty('apartmentVentilation/logic/boostSensoricOn/actions/2/addon-id','heating-controller');
		
	registerTrigger(Property.getNode('apartmentVentilation/logic/boostSensoricOn').getPath(),'action_execute',{});

	Property.setProperty('apartmentVentilation/logic/boostSensoricOff/actions/1/type','zone-scene');
	Property.setProperty('apartmentVentilation/logic/boostSensoricOff/actions/1/zone',0);
	Property.setProperty('apartmentVentilation/logic/boostSensoricOff/actions/1/group',64);
	Property.setProperty('apartmentVentilation/logic/boostSensoricOff/actions/1/delay',0);
	Property.setProperty('apartmentVentilation/logic/boostSensoricOff/actions/1/scene',parseInt("" + nominalLevel,10));
	Property.setProperty('apartmentVentilation/logic/boostSensoricOff/actions/2/type','change-addon-state');
	Property.setProperty('apartmentVentilation/logic/boostSensoricOff/actions/2/statename','apartmentVentilationBoost');
	Property.setProperty('apartmentVentilation/logic/boostSensoricOff/actions/2/state','inactive');
	Property.setProperty('apartmentVentilation/logic/boostSensoricOff/actions/2/addon-id','heating-controller');

	
	registerTrigger(Property.getNode('apartmentVentilation/logic/boostSensoricOff').getPath(),'action_execute',{});
	lInfo.logln('setSensoricBoost done');
}

function setAutoOffBoostTimer(nominalLevel) {
	lInfo.logln('setAutoOffBoostTimer');

	var AutoOffTimer=24*60*60;
	if (Property.getNode('apartmentVentilation/boostStopTime')!=null) 
		AutoOffTimer=parseInt(''+Property.getNode('apartmentVentilation/boostStopTime').getValue(),10);
	lInfo.logln('Autoff timer: ' + AutoOffTimer);
	Property.setProperty('apartmentVentilation/logic/boostAutoOffTimer/triggers/1/type','addon-state-change');
	Property.setProperty('apartmentVentilation/logic/boostAutoOffTimer/triggers/1/addon-id','heating-controller');
	Property.setProperty('apartmentVentilation/logic/boostAutoOffTimer/triggers/1/name','apartmentVentilationBoost');
	Property.setProperty('apartmentVentilation/logic/boostAutoOffTimer/triggers/1/state','active');
	Property.setProperty('apartmentVentilation/logic/boostAutoOffTimer/damping/interval',AutoOffTimer);
	Property.setProperty('apartmentVentilation/logic/boostAutoOffTimer/damping/rewindTimer',true);
	Property.setProperty('apartmentVentilation/logic/boostAutoOffTimer/lag/delay',AutoOffTimer);
	Property.setProperty('apartmentVentilation/logic/boostAutoOffTimer/lag/reschedule',true);

	Property.setProperty('apartmentVentilation/logic/boostAutoOffTimer/actions/1/type','zone-scene');
	Property.setProperty('apartmentVentilation/logic/boostAutoOffTimer/actions/1/zone',0);
	Property.setProperty('apartmentVentilation/logic/boostAutoOffTimer/actions/1/group',64);
	Property.setProperty('apartmentVentilation/logic/boostAutoOffTimer/actions/1/delay',0);
	Property.setProperty('apartmentVentilation/logic/boostAutoOffTimer/actions/1/scene',parseInt("" + nominalLevel,10));
	Property.setProperty('apartmentVentilation/logic/boostAutoOffTimer/actions/2/type','change-addon-state');
	Property.setProperty('apartmentVentilation/logic/boostAutoOffTimer/actions/2/statename','apartmentVentilationBoost');
	Property.setProperty('apartmentVentilation/logic/boostAutoOffTimer/actions/2/state','inactive');
	Property.setProperty('apartmentVentilation/logic/boostAutoOffTimer/actions/2/addon-id','heating-controller');
	Property.setProperty('apartmentVentilation/logic/boostAutoOffTimer/actions/2/delay',0);

	Property.setProperty('apartmentVentilation/logic/boostAutoOffTimer/conditions/addon-states/heating-controller/apartmentVentilationBoost',1);
	
	registerTrigger(Property.getNode('apartmentVentilation/logic/boostAutoOffTimer').getPath(),'action_execute',{});
	lInfo.logln('setAutoOffBoostTimer done');
}

function evaluateVentilation() {
	var nominalLevel=-1;
	registerState('apartmentVentilationBoost',true);
	unregisterTrigger('/scripts/heating-controller/apartmentVentilation/logic/present');
	unregisterTrigger('/scripts/heating-controller/apartmentVentilation/logic/absent');
	if (Property.getNode('apartmentVentilation/logic')!=null) {
		Property.getNode('apartmentVentilation/logic').removeChild('present');
		Property.getNode('apartmentVentilation/logic').removeChild('absent');
	}
	removeBoostState();
	removeSensoricBoost();	
	lInfo.logln('settting ');
	if (Property.getNode('apartmentVentilation/nominalLevel')!=null) {
		nominalLevel=parseInt('' + Property.getNode('apartmentVentilation/nominalLevel').getValue(),10);
		lInfo.logln('nominallevel: ' + nominalLevel);
		if (Property.getNode('apartmentVentilation/absentLevel')) {
			setPresentAbsentLogic(nominalLevel,Property.getNode('apartmentVentilation/absentLevel').getValue());
		}
		var fSkip=false;
		if (Property.getNode('apartmentVentilation/humidityLimit')!=null) {			
			var humidityLimit=Property.getNode('apartmentVentilation/humidityLimit').getValue();
			fSkip=true;
			setBoostState();
			setSensoricBoost(humidityLimit,nominalLevel,0); 		
		}
		if (Property.getNode('apartmentVentilation/boostStopTime')!=null) {
			if (!fSkip)
				setBoostState();
			setAutoOffBoostTimer(nominalLevel);
			lInfo.logln('boostStopTime: ' + nominalLevel);
		}
	}
}

Property.load();
if (raisedEvent.name == 'heating-controller.apartment-ventilation') {
	if (raisedEvent.parameter.actions=='setUBNDWEM') { //user bekommt nicht das was er meint
		storeParameter("apartmentVentilation/ubndwem",true);
		new Event('heating-controller.apartment-ventilation',{actions:'evaluateVentilation'}).raise();
		Property.store();
	}
	if (raisedEvent.parameter.actions=='resetUBNDWEM') { //user bekommt nicht das was er meint
		storeParameter("apartmentVentilation/ubndwem",false);
		new Event('heating-controller.apartment-ventilation',{actions:'evaluateVentilation'}).raise();
		Property.store();
	}

	if (raisedEvent.parameter.actions=='setNominalLevel') {
		storeParameter("apartmentVentilation/nominalLevel",raisedEvent.parameter.normalLevel);
		new Event('heating-controller.apartment-ventilation',{actions:'evaluateVentilation'}).raise();
		Property.store();
	}
	
	if (raisedEvent.parameter.actions=='enableAbsentReducment') {
		storeParameter("apartmentVentilation/absentLevel",raisedEvent.parameter.reduceLevel);
		new Event('heating-controller.apartment-ventilation',{actions:'evaluateVentilation'}).raise();
		Property.store();
	}
	if (raisedEvent.parameter.actions=='disableAbsentReducment') {
		if (Property.getNode("apartmentVentilation")!=null)
			Property.getNode("apartmentVentilation").removeChild('absentLevel');		
		new Event('heating-controller.apartment-ventilation',{actions:'evaluateVentilation'}).raise();
		Property.store();
	}

	if (raisedEvent.parameter.actions=='setAutoOffBoost') {
		storeParameter("apartmentVentilation/boostStopTime",raisedEvent.parameter.maxTime);
		new Event('heating-controller.apartment-ventilation',{actions:'evaluateVentilation'}).raise();
		Property.store();
		lInfo.logln("setAutoOffBoost");
	}
	if (raisedEvent.parameter.actions=='disableAutoOffBoost') {
		if (Property.getNode("apartmentVentilation")!=null)
			Property.getNode("apartmentVentilation").removeChild('boostStopTime');		
		new Event('heating-controller.apartment-ventilation',{actions:'evaluateVentilation'}).raise();
		Property.store();
	}
	
	if (raisedEvent.parameter.actions=='setBoostOnHumidity') {
		storeParameter("apartmentVentilation/humidityLimit",raisedEvent.parameter.maxHuminity);
		new Event('heating-controller.apartment-ventilation',{actions:'evaluateVentilation'}).raise();
		Property.store();		
	}
	if (raisedEvent.parameter.actions=='resetBoostOnHumidity') {		
		if (Property.getNode("apartmentVentilation")!=null)
			Property.getNode("apartmentVentilation").removeChild('humidityLimit');		
		new Event('heating-controller.apartment-ventilation',{actions:'evaluateVentilation'}).raise();
		Property.store();
	}
	
	if (raisedEvent.parameter.actions=='evaluateVentilation') {
		evaluateVentilation();
		new Event('heating-controller.answer',{}).raise();
	}
}

if (raisedEvent.name=='model_ready') {
	if (Property.getNode('apartmentVentilation/boostStopTime')==null) {
		storeParameter("apartmentVentilation/boostStopTime",3600);
		Property.store();
	}
	evaluateVentilation();	
}