Ext.define('DSS.component.GeneralPanel', {
	extend : 'Ext.panel.Panel',
    mixins : {
        observable : 'Ext.util.Observable'
    },
    
    radioHeatingAppGeneralSwitch:null,
    radioSingleMultihouse:null,
    radioHeatingSystemCapabilities:null,
    loadRoomParameter : function(grid) {
        var loadError = false;
		/*
		 * {name : 'zoneID}, {name : 'baseMode'}, {name :
		 * 'temperature'}, {name : 'lastTS'}, {name : 'sensorID'}, {name :
		 * 'actors'}, {name : 'states'}, {name : 'flags'}
		 */
		var sString = dss.ajaxSyncRequest('/json/property/query2', {
			'query' : '/scripts/heating-controller/controllerDefinitions/*(*)'
		});

		try {
			var result = Ext.JSON.decode(sString);
			this.heatingStore_controllerMode.removeAll();
			this.heatingStore_controllerMode.add({
				id : '0',
				name : _('no controller active'),
				mode : 0,
				object : {
					controllerMode : ControlModes.cControlModeOff
				}
			});
			for ( var sIndex in result.result) {
				var oObject = result.result[sIndex];
				this.heatingStore_controllerMode.add({
					id : '' + oObject.id,
					name : _(oObject.name),
					mode : parseInt('' + oObject.controllerMode),
					object : oObject
				});
			}
			this.heatingStore_controllerMode.add({
				id : '-2',
				name : _('default zone follower'),
				mode : 0,
				object : {
					controllerMode : ControlModes.cControlModeZoneFollower
				}
			});
			this.heatingStore_controllerMode.add({
				id : '-3',
				name : _('default fixed value'),
				mode : 0,
				object : {
					controllerMode : ControlModes.cControlModeFixedValue
				}
			});
			this.heatingStore_controllerMode.add({
				id : '-5',
				name : _('automatic mode'),
				mode : 0,
				object : {
					controllerMode : ControlModes.cControlModeAutomatic
				}
			});

		} catch (e) {

		}

		this.basePanel.controllerDefined = false;
		var allreadyDefinedController = {};
		var allreadyDefinedEmergeny = {};
		var alreadyDefinedAutoselect = {};
        this.basePanel.autoSelectMessage = [];
		var sString = dss.ajaxSyncRequest('/json/property/query2', {
			'query' : '/scripts/heating-controller/controllerConfig/*(*)'
		});
		try {
			var result = Ext.JSON.decode(sString);
			for ( var sIndex in result.result) {
				var oObject = result.result[sIndex];
				allreadyDefinedController[oObject.zoneID] = parseInt("" + oObject.definitionID, 10);
				if (oObject.emergenyValue != null)
					allreadyDefinedEmergeny[oObject.zoneID] = parseInt("" + oObject.emergenyValue, 10);
				if (oObject.autoselect != null) {
					alreadyDefinedAutoselect[oObject.zoneID] = oObject.autoselect;
				}
			}
		} catch (e) {

		}

		var oRArray = [];
		try {
			var zonesToBeShown=[];
            var zones = dss.staticDataModel.getZoneArray();
            for (var iIndex = 0; iIndex < zones.length; iIndex++ ) {
                var zone = zones[iIndex];
                if (zone.ZoneID === 0) {
                    continue;
                }
                var oDevices = dss.staticDataModel.getDevicesForZone(zone.ZoneID, 48);
                for (var jIndex = 0; jIndex < oDevices.length; jIndex++) {
                    if (oDevices[jIndex].outputMode > 0) {
                        zonesToBeShown.push(zone.ZoneID);
                        continue;
                    }
                }
                if (this.basePanel.zoneControlValues[zone.ZoneID] != null) {
                    if (this.basePanel.zoneControlValues[zone.ZoneID].sensors != null) {
                        for (var jIndex = 0; jIndex < this.basePanel.zoneControlValues[zone.ZoneID].sensors.length; jIndex++) {
                            if (this.basePanel.zoneControlValues[zone.ZoneID].sensors[jIndex].sensorType == 9) {
                                zonesToBeShown.push(zone.ZoneID);
                                continue;
                            }
                        }
                    }
                }
            }

			for (var aKey in this.basePanel.zoneControlValues) {
				if (this.basePanel.zoneControlValues[aKey].IsConfigured) {
					var fFound=false;
					for (var jIndex=0;jIndex<zonesToBeShown.length;jIndex++){
						if ((""+aKey)==(""+zonesToBeShown[jIndex]))
							fFound=true;
					}
					if (!fFound) {
						zonesToBeShown.push(this.basePanel.zoneControlValues[aKey].id);
					}
				}
            }
			for (var kIndex=0;kIndex<zonesToBeShown.length;kIndex++) {	
				aKey=zonesToBeShown[kIndex];
				
				var fFound=false;
				for (var rIndex=0;rIndex<oRArray.length;rIndex++) {
					if (oRArray[rIndex].zoneID==aKey)
						fFound=true;
				}
				if (!fFound) {
				
					var sensorID = null;
					if (this.basePanel.zoneControlValues[aKey] != null) {
						if (this.basePanel.zoneControlValues[aKey].sensors != null) {
							for ( var jIndex = 0; jIndex < this.basePanel.zoneControlValues[aKey].sensors.length; jIndex++) {
								if (this.basePanel.zoneControlValues[aKey].sensors[jIndex].sensorType == 9)
									sensorID = this.basePanel.zoneControlValues[aKey].sensors[jIndex].dsuid;
							}
						}
					}

					var oObject = {
						zoneID : aKey,
                        zoneName : dss.staticDataModel.getNameForZone(aKey),
						sensorID : sensorID,
						actors : [],
						parameter : null,
						baseMode : 0
					};

					var oDevices = dss.staticDataModel.getDevicesForZone(aKey, 48);
					for ( var iIndex = 0; iIndex < oDevices.length; iIndex++) {
						if (oDevices[iIndex].outputMode > 0)
							oObject.actors.push(oDevices[iIndex]);
					}

					if (this.basePanel.zoneControlValues[aKey] != null) {
						if (alreadyDefinedAutoselect[aKey]) {
							oObject.baseMode = -5;
							if (allreadyDefinedController[aKey] != null) {
                                var msg ='';
                                switch (allreadyDefinedController[aKey]) {
                                    case AutomaticModeError.AutoUnknown:
                                    case AutomaticModeError.AutoOff: //intend fall through
                                        oObject.parameter = BaseModeDefinitions.Off;
                                        msg = Ext.String.format2(_('For room {zonename} no operation mode could be defined'), {
                                            zonename : dss.staticDataModel.getNameForZone(aKey)}); 
                                        break;
                                    case AutomaticModeError.AutoNothingSelected:
                                        oObject.baseMode = BaseModeDefinitions.AutoFailed;
                                        oObject.parameter = 0;
                                        msg = Ext.String.format2(_('No controller mode for room {zonename} could automatically be selected. There is no sensor in this room'), {
                                            zonename : dss.staticDataModel.getNameForZone(aKey)});
                                        break;
                                    case AutomaticModeError.AutoSelectionFailed:
                                        oObject.baseMode = BaseModeDefinitions.AutoFailed;
                                        oObject.parameter = 0;
                                        msg = Ext.String.format2(_('No controller mode for room {zonename} could automatically be selected. Please choose a controller mode.'), {
                                            zonename : dss.staticDataModel.getNameForZone(aKey)});
                                        break;
                                    case AutomaticModeError.AutoSelectionNotPossible:
                                        oObject.baseMode = BaseModeDefinitions.AutoNoValves;
                                        oObject.parameter = 0;
                                        msg = Ext.String.format2(_('No controller mode for room  {zonename} could automatically be selected. Please select the native device in the property of the device'), {
                                            zonename : dss.staticDataModel.getNameForZone(aKey)});
                                        break;
                                    case AutomaticModeError.AutoSelectionNoController:
                                        oObject.baseMode = BaseModeDefinitions.AutoNoController;
                                        oObject.parameter = 0;
                                        msg = Ext.String.format2(_('No controller for room {zonename} could automatically be selected. Please ensure that all devices are connected to a dSM that supports controllers.'), {
                                            zonename : dss.staticDataModel.getNameForZone(aKey)});
                                        break;
                                    default:
                                        oObject.parameter = allreadyDefinedController[aKey];
                                        break;
                                }
                                if (msg != '') {
                                    this.basePanel.autoSelectMessage.push(msg);
                                }
                            }
						}
						else if (this.basePanel.zoneControlValues[aKey].ControlMode != null) {
							if (this.basePanel.zoneControlValues[aKey].ControlMode == 1) {
								oObject.baseMode = -1;
								if (allreadyDefinedController[aKey] != null) {
									if (allreadyDefinedController[aKey] > 0) {
										oObject.baseMode = allreadyDefinedController[aKey];
									}
								}
							}
							if (this.basePanel.zoneControlValues[aKey].ControlMode == 2)
								oObject.baseMode = -2;
							if (this.basePanel.zoneControlValues[aKey].ControlMode == 3)
								oObject.baseMode = -3;
							if (this.basePanel.zoneControlValues[aKey].ControlMode == 4)
								oObject.baseMode = -4;
						}
					}
					if (allreadyDefinedEmergeny[aKey] != null) {
						oObject.emergenyValue = allreadyDefinedEmergeny[aKey];
                    } else {
                        oObject.emergenyValue = 75;
                    }
					if (oObject.baseMode == -2) {							
						oObject.referenceZone = this.basePanel.zoneControlValues[aKey].config.ReferenceZone;
						oObject.ctrlOffset = this.basePanel.zoneControlValues[aKey].config.CtrlOffset;                            
					}
					if (oObject.baseMode != 0) {
						this.basePanel.controllerDefined = true;
					}
                    if ((sensorID != null) || (oObject.actors.length > 0) || (oObject.baseMode != 0 && oObject.baseMode != -5)) {
                        oRArray.push(oObject);
                    }
				}
			}
		} catch (e) {

		}
		if (grid != null) {
			this.roomGrid = grid;
            grid.editorWindow.editControls['referenceZone'].cboCombo.getStore().removeAll();
            for ( var iIndex = 0; iIndex < this.basePanel.usableZones.length; iIndex++) {
                var oObject = this.basePanel.usableZones[iIndex];
                if (oObject.ZoneID != 0) {
                    grid.editorWindow.editControls['referenceZone'].cboCombo.getStore().add({
                        id : '' + oObject.ZoneID,
                        name : oObject.name
                    });
                }
            }
        }
		this.roomGrid.loadParameter(oRArray);
		this.loadGeneralPanel();
		if (HeatingControl != undefined) {
			tabActivation(!this.basePanel.controllerDefined);
		}
		if (this.waitDialog != null) {
			this.waitDialog.hide();
			this.waitDialog = null;
		}
        if (grid) {
            if (loadError) {
                grid.setStatus(_('Error'));
            } else {
                grid.setStatus(_('Ready'));
            }
        }
	},
	waitAndReloadRoomParameter : function() {
		var me = this;
		var iSubscriptID = Math.floor(Math.random() * 100000000000);
		dss.ajaxSyncRequest('/json/event/subscribe', {
			subscriptionID : iSubscriptID,
			name : 'heating-controller.answer'
		});
		dss.ajaxAssyncRequestWithoutAnswer('/json/event/get', {
			subscriptionID : iSubscriptID,
			timeout : 60 * 1000
		}, function() {
			this.temperatureControlValues = null;
			me.basePanel.fetchZoneControlValues(true);
			me.loadRoomParameter(me.roomPanel);
			me.basePanel.timePanel.loadTimedSettings();
			me.basePanel.loadStartPanel();
			/*me.temperaturePanel.fireEvent('loadDataStore', me.temperaturePanel);
			me.coolingPanel.fireEvent('loadDataStore', me.coolingPanel);
			me.loadTimedSettings();
			me.updateTimeStore();
			me.loadStatusPanel();*/
			dss.ajaxAssyncRequestWithoutAnswer('/json/event/unsubscribe', {
				subscriptionID : iSubscriptID,
				name : 'heating-controller.answer'
			});
		});

	},
    loadGeneralPanel : function() {
		this.radioSingleMultihouse.suspendEvents();
		this.radioHeatingAppGeneralSwitch.suspendEvents();
		this.radioHeatingSystemCapabilities.suspendEvents();
		var sString = dss.ajaxSyncRequest('/json/property/query2', {
			'query' : '/scripts/heating-controller/generalSettings(*)/*(*)'
		});
		try {
			var result = Ext.JSON.decode(sString);
			if (result.ok) {
				if (result.result != null)
					if (result.result.generalSettings != null) {
						if (result.result.generalSettings.apartmentType != null) {
							this.radioSingleMultihouse.setValue({
								singleApartment : result.result.generalSettings.apartmentType
							});
						}
						if (result.result.generalSettings.heatingEnabled != null) {
							this.radioHeatingAppGeneralSwitch.setValue({
								centralSwitch : result.result.generalSettings.heatingEnabled
							});
						} else {
                            dss.raiseEvent('heating-controller.general-settings', {
                                actions : 'setApartmentClimateControl',
                                value : true
                            });
                            this.radioHeatingAppGeneralSwitch.setValue({
								centralSwitch : true
							});
                        }
						if ((result.result.generalSettings.apartmentType != null) && (result.result.generalSettings.heatingEnabled != null)) {
							this.generalSettingsMissing = false;
						}
                        if ((result.result.generalSettings.capabilities != null)) {
                            this.basePanel.hasCoolingCapability = result.result.generalSettings.capabilities.coolingSupported;
                            var hasHeatingCapability = result.result.generalSettings.capabilities.heatingSupported;
                            this.radioHeatingSystemCapabilities.setValue({
                                heatingSystem : (this.basePanel.hasCoolingCapability ? 2 : 1)
                            });
                            if (this.basePanel.coolingTab!=null) {
	                            if (this.basePanel.hasCoolingCapability) {
	                                this.basePanel.coolingTab.tab.show();
	                            } else {
	                                this.basePanel.coolingTab.tab.hide();
	                            }
                            }
                        }
					}
			}

		} catch (e) {
		}
		this.radioSingleMultihouse.resumeEvents();
		this.radioHeatingAppGeneralSwitch.resumeEvents();
        this.radioHeatingSystemCapabilities.resumeEvents();
	},
	waitAndReloadGeneralSettings : function() {
		var me = this;
		var iSubscriptID = Math.floor(Math.random() * 100000000000);
		dss.ajaxSyncRequest('/json/event/subscribe', {
			subscriptionID : iSubscriptID,
			name : 'heating-controller.answer'
		});
		dss.ajaxAssyncRequestWithoutAnswer('/json/event/get', {
			subscriptionID : iSubscriptID,
			timeout : 60 * 1000
		}, function() {
			me.loadGeneralPanel();
			me.basePanel.loadTimedSettings();
			if (HeatingControl != undefined) {
				tabActivation(!me.basePanel.controllerDefined);
			}
			dss.ajaxAssyncRequestWithoutAnswer('/json/event/unsubscribe', {
				subscriptionID : iSubscriptID,
				name : 'heating-controller.answer'
			});
		});

	},

    constructor : function(config) {
    	this.basePanel=config.basePanel;
		var me = this;
		this.radioSingleMultihouse = Ext.create('Ext.form.RadioGroup', {
			labelWidth : 230,
			width : 800,
			fieldLabel : _('Type of building'),
			items : [ {
				boxLabel : _('Singleapartmenthouse'),
				name : 'singleApartment',
				inputValue : 1,
				style : {
					padding : '10px',
					color : "#005138"
				}
			}, {
				boxLabel : _('Multiapartmenthouse'),
				name : 'singleApartment',
				inputValue : 2,
				style : {
					padding : '10px',
					color : "#005138"
				}
			} ],
			listeners : {
				change : function(oThis, newValue) {
					dss.raiseEvent('heating-controller.general-settings', {
						actions : 'setApartmentType',
						value : newValue.singleApartment
					});
					me.waitAndReloadGeneralSettings();
				}
			}
		});
		this.radioHeatingAppGeneralSwitch = Ext.create('Ext.form.RadioGroup', {
			labelWidth : 230,
			width : 800,
			fieldLabel : _('Heating control'),
			items : [ {
				boxLabel : _('On'),
				name : 'centralSwitch',
				inputValue : true,
				style : {
					padding : '10px',
					color : "#005138"
				}
			}, {
				boxLabel : _('Off'),
				name : 'centralSwitch',
				inputValue : false,
				style : {
					padding : '10px',
					color : "#005138"
				}
			} ],
			listeners : {
				change : function(oThis, newValue) {
					dss.raiseEvent('heating-controller.general-settings', {
						actions : 'setApartmentClimateControl',
						value : newValue.centralSwitch
					});
					me.waitAndReloadGeneralSettings();
				}
			}
		});
        this.radioHeatingSystemCapabilities = Ext.create('Ext.form.RadioGroup', {
            labelWidth : 230,
            width : 800,
            fieldLabel : _('Heating system capabilities'),
            items : [ {
                boxLabel : _('Heating'),
                name : 'heatingSystem',
                inputValue : 1,
                style : {
                    padding : '10px',
                    color : "#005138"
                }
            }, {
                boxLabel : _('Heating and cooling'),
                name : 'heatingSystem',
                inputValue : 2,
                style : {
                    padding : '10px',
                    color : "#005138"
                }
            } ],
            listeners : {
                change : function(oThis, newValue) {
                    var heating = true;
                    var cooling = false;
                    if (newValue.heatingSystem == 2) {
                        cooling = true;
                    }
                    dss.raiseEvent('heating-controller.general-settings', {
                        actions : 'setCapabilities',
                        value : 'dummy',
                        heating : heating,
                        cooling : cooling
                    });
                    me.waitAndReloadGeneralSettings();
                }
            }
        });

		if (this.heatingStore_controllerMode == null) {
			this.heatingStore_controllerMode = Ext.create('Ext.data.Store', {
				storeId : 'heatingStore_controllerMode',
				fields : [ 'id', 'mode', 'name', 'object' ],
				proxy : {
					type : 'memory',
					reader : {
						type : 'json',
						root : 'items'
					}
				}
			});
		}
		if (this.heatingStore_referenceZone == null) {
			this.heatingStore_referenceZone = Ext.create('Ext.data.Store', {
				storeId : 'heatingStore_referenceZone',
				fields : [ 'id', 'name' ],
				proxy : {
					type : 'memory',
					reader : {
						type : 'json',
						root : 'items'
					}
				}
			});
		}
		for ( var iIndex = 0; iIndex < this.basePanel.usableZones.length; iIndex++) {
			var oObject = this.basePanel.usableZones[iIndex];
			if (oObject.ZoneID != 0) {
				this.heatingStore_referenceZone.add({
					id : '' + oObject.ZoneID,
					name : oObject.name
				});
			}
		}

		var ctrlOffset = Ext.create('Ext.form.field.Number', {
			fieldLabel : _('Offset'),
			labelWidth : 210,
			minValue : -100,
			maxValue : 300,
			value : 0,
			step : 1,
			decimalPrecision : 0,
			width : 300,
            id : 'offsetNumber'
		});
		var ctrlEmergenyValue = Ext.create('Ext.form.field.Number', {
			fieldLabel : _('Emergency Value'),
			labelWidth : 210,
			minValue : 0,
			maxValue : 100,
			value : 0,
			step : 1,
			decimalPrecision : 0,
			width : 300,
            id : 'emergencyNumber'
		});

		var ctrlEmergenyPanel = Ext.create('Ext.panel.Panel', {
			border : false,
			layout : 'hbox',
			height : 24,
			width : 600,
			items : [ ctrlEmergenyValue, {
				xtype : 'panel',
				height : 24,
				width : 400,
				margin : '3 0 0 5',
				border : false,
				html : '<span style="color:#005138">' + _('%') + '</span>'
			} ]
		});
		ctrlEmergenyPanel.setValue = function(val) {
			ctrlEmergenyValue.setValue(val);
		};
		ctrlEmergenyPanel.getValue = function() {
			return ctrlEmergenyValue.getValue();
		};
		ctrlEmergenyPanel.resetValue = function() {
			ctrlEmergenyValue.resetValue();
		};
		ctrlEmergenyPanel.isValid = function() {
			return ctrlEmergenyValue.isValid();
		};

		var ctrlPanel = Ext.create('Ext.panel.Panel', {
			border : false,
			layout : 'hbox',
			height : 24,
			width : 600,
			items : [ ctrlOffset, {
				xtype : 'panel',
				height : 24,
				width : 400,
				margin : '3 0 0 5',
				border : false,
				html : '<span style="color:#005138">'+_('% on the valve settings from the referenced zone') + '</span>'
			} ]
		});
		ctrlPanel.setValue = function(val) {
			ctrlOffset.setValue(val);
		};
		ctrlPanel.getValue = function() {
			return ctrlOffset.getValue();
		};
		ctrlPanel.resetValue = function() {
			ctrlOffset.resetValue();
		};
		ctrlPanel.isValid = function() {
			return ctrlOffset.isValid();
		};
        
        var ctrlAutoselectHelp = Ext.create('Ext.panel.Panel', {
			border : false,
			layout : 'hbox',
			height : 48,
			width : 700,
			items : [ {
				xtype : 'panel',
				height : 48,
				width : 600,
				margin : '3 0 0 5',
				border : false,
				html : '<span style="color:#005138">' + _('The operation mode is automatically determined by the connected device.') +  '<br>' + _('This is defined for each actuator under hardware / device properties.') + '</span>'
			} ]
        });
        ctrlAutoselectHelp.setValue = function(val) {};
		ctrlAutoselectHelp.getValue = function() {return null;};
		ctrlAutoselectHelp.resetValue = function() {};

        ctrlAutoselectHelp.isValid = function() {
            return true;
        };
        
        var roomNameField = Ext.create('Ext.form.field.Display', {
                    border : 0,
                    height:18,
                    fieldStyle: {'fontWeight' : 'bold'}  
        });
		var oConfigRoomMode = {
			defaultSortCol : 'zoneID',
			storeConfig : {
				storeId : 'zoneParameterStore',
				fields : [ {
					name : 'zoneID'
				}, {
					name : 'zoneName'
				}, {
					name : 'baseMode'
				}, {
					name : 'controlMode'
				}, {
					name : 'sensorID'
				}, {
					name : 'actors'
				}, {
					name : 'ctrlOffset'
				}, {
					name : 'referenceZone'
				}, {
					name : 'emergenyValue'
				}, {
                    name : 'parameter'
                }]
			},
			columns : [ {
				header : _('zone'),
				dataIndex : 'zoneID',
				xtype : 'textcolumn',
				flex : 1,
				customColumnRenderer : function(val) {
					return dss.staticDataModel.getNameForZone(val);
				}
			}, {
				header : _('base mode'),
				dataIndex : 'baseMode',
				xtype : 'textcolumn',
				flex : 1,
				customColumnRenderer : function(val, metadata, record, rowIdx, colIdx, store, view) {
					if (val == "") {
						var oRecord = me.heatingStore_controllerMode.findRecord('mode', 0);
						return oRecord.get('name');
					} else {
/*
* baseMode definitions: 0 Aus 1 .. n Template ID's -1 Custom PID, no cloud
* template id -2 Zone Follower -3 Fixed -4 Manual -5 Automatic - PID -6
* Automatic - Failed -7 Automatic - All valves are Unknown -8 Automatic -
* no sensor -9 Automatic - no controller
*/
						if (val == BaseModeDefinitions.CustomPID)
							return _('custom PID-Controller');
						if (val == BaseModeDefinitions.ZoneFollower)
							return Ext.String.format2(_('following {zonename} with offset {offset}'), {
								zonename : dss.staticDataModel.getNameForZone(record.get('referenceZone')),
								offset : record.get('ctrlOffset')
							});
						if (val == BaseModeDefinitions.Manual) {
							return _('manual mode');
						}
						if ( (val == BaseModeDefinitions.AutoPID) || 
						    (val == BaseModeDefinitions.AutoFailed) || 
						    (val == BaseModeDefinitions.AutoNoValves) || 
						    (val == BaseModeDefinitions.AutoNoSensor) || 
						    (val == BaseModeDefinitions.AutoNoController)) {
							var returnString = _('automatic mode');
							var oRecord = me.heatingStore_controllerMode.findRecord('id', (record.get('parameter')+''));
							if (oRecord) {
								returnString += ' (';
								returnString += oRecord.get('name');
								returnString += ')';
							}
							return returnString;
						}
						var oRecord = me.heatingStore_controllerMode.findRecord('id', val);
						return oRecord.get('name');
					}
				}
			}, {
                header : _('Emergency setting'),
                dataIndex : 'emergenyValue',
                xtype : 'textcolumn',
                flex : 1,
                customColumnRenderer : function(val, metadata, record) {
                    var sText = ("" + val).replace('.', ',') + " %";
                    if (val == null) {
                        sText = '-';
                    } else if (val == "") {
                        sText = '-';
                    }
                    return sText;
                }
            }, {
				header : _('Roomsensor defined'),
				dataIndex : 'sensorID',
				flex : 1,
				xtype : 'textcolumn',
				customColumnRenderer : function(val) {
					if (val != null) {
						var oDevice = dss.staticDataModel.getDevice(val);
                        var sString = '<table><tr><td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td>';
                        sString += '<td' + (oDevice.present ? '' : ' style="color:grey;"') + '>' + oDevice.name + '</td></tr></table>';
						return sString;
					} else
						return _('no');
				}
			}, {
				header : _('Actors defined'),
				dataIndex : 'actors',
				flex : 1,
				xtype : 'textcolumn',
				customColumnRenderer : function(val) {
					if (val.length == 0)
						return _('no');
					var sString = '<table>';
					for ( var iIndex = 0; iIndex < val.length; iIndex++) {
						oDevice = val[iIndex];
						sString += '<tr><td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td>';

						sString += '<td' + (oDevice.present ? '' : ' style="color:grey;"') + '>' + oDevice.name + '</td></tr>';
					}
					return sString + '</table>';
				}
			} ],
			buttonText : {
				editButton : _('Edit Roomsettings')
			},
			editorConfig : {
				title : _('Roomsettings'),
				staticControls : [ {
					type : 'custom',
                    control : roomNameField,
					id : 'zoneName'
				}, {
					type : 'combobox',
					label : _('Base Mode'),
					storeid : 'heatingStore_controllerMode',
					storedisplayid : 'name',
					storevalueid : 'id',
					labelWidth:210,
					id : 'baseMode'
				}, {
					type : 'combobox',
					label : _('referenced Zone'),
					storeid : 'heatingStore_referenceZone',
					storedisplayid : 'name',
					storevalueid : 'id',
					labelWidth:210,
					id : 'referenceZone'
				}, {
					type : 'custom',
					label : _('Offset'),
					id : 'ctrlOffset',
					control : ctrlPanel
				}, {
					type : 'custom',
					id : 'emergenyValue',
					control : ctrlEmergenyPanel
				}, {
					type : 'hidden',
					label : _('id'),
					id : 'zoneID'
				}, {
                    type : 'custom',
                    label : '',
                    id : 'ctrlAutoselectHelp',
                    control : ctrlAutoselectHelp
                    
                }]
			},
			defaultNewEntryValues : {
				ctrlOffset : 0,
				emergenyValue : 75
			},
			listeners : {
				'loadDataStore' : function(grid) {
					me.loadRoomParameter(grid);
				},
				'saveEntry' : function(grid, values) {

					var controlerMode = values.baseMode;
					if (isNaN(controlerMode)) {
						return;
					}

					me.waitDialog = new Ext.LoadMask(Ext.getBody(), {
						msg : _('Please wait, changing controller mode ...'),
						indicator : false
					});
					me.waitDialog.show();

					try {
						var iZoneID = values.zoneID;
						var controlerMode = values.baseMode;

						var oRecord = me.heatingStore_controllerMode.findRecord('id', controlerMode);

						var oDataObject = oRecord.get('object');

						if (oDataObject.controllerMode == ControlModes.cControlModeOff /* 0 */) {
							dss.raiseEvent('heating-controller.controller-config', {
								actions : 'resetControllerMode',
								zoneID : iZoneID
							});
						}
						if (oDataObject.controllerMode == ControlModes.cControlModePID /* 1 */) {

							dss.raiseEvent('heating-controller.controller-config', {
								actions : 'setControllerModePID',
								zoneID : iZoneID,
								definitionID : controlerMode,
								emergency : values.emergenyValue

							});
						}
						if (oDataObject.controllerMode == ControlModes.cControlModeZoneFollower /* 2 */) {

							dss.raiseEvent('heating-controller.controller-config', {
								actions : 'setControllerModeZoneFollower',
								zoneID : iZoneID,
								followedZone : values.referenceZone,
								offset : values.ctrlOffset,
								emergency : values.emergenyValue
							});
						}
						if (oDataObject.controllerMode == ControlModes.cControlModeFixedValue /* 3 */) {
							dss.raiseEvent('heating-controller.controller-config', {
								actions : 'setControllerModeFixedValue',
								zoneID : iZoneID
							});
						}
						if (oDataObject.controllerMode == ControlModes.cControlModeAutomatic /* 5 */) {
							dss.raiseEvent('heating-controller.controller-config', {
								actions : 'setControllerModeAutomatic',
								zoneID : iZoneID,
								definitionID : -1,
								autoselect : 1,
								emergency : values.emergenyValue
							});
						}
						me.waitAndReloadRoomParameter(grid);

					} catch (e) {
						// hide dialog and display error message
						me.waitDialog.hide();
						Ext.MessageBox.show({
							title: _('Error'),
							msg: _('Could not save data'),
							buttons: Ext.MessageBox.OK,
							buttonText: {
								ok: _('ok')
							},
						});
					}
					
				},
				'enableEntry' : function(grid, entry) {
					me.waitAndReloadRoomParameter(grid);
				},
				'disableEntry' : function(grid, entry) {
					me.waitAndReloadRoomParameter(grid);
				}
			}

		};

		var roomPanel = Ext.create('DSS.gridPanel', oConfigRoomMode);
		var baseModeControl = roomPanel.editorWindow.editControls['baseMode'].addListener('change', function() {
			if (isNaN(this.getValue())) {
				return;
			}
			if (this.getValue() == BaseModeDefinitions.CustomPID) {
				this.referenceZoneID.setVisible(false);
                this.ctrlOffset.getChildByElement('offsetNumber').allowBlank=true;
				this.ctrlOffset.setVisible(false);
                this.emergenyValue.getChildByElement('emergencyNumber').allowBlank=false;
				this.emergenyValue.setVisible(true);
				if (this.zoneID != null) {
					var selectedZone = this.zoneID.getValue();
					var emergencyValue = getEmergencyValueForZone(selectedZone);
					this.emergenyValue.setValue(emergencyValue);
				} else {
					this.emergenyValue.setValue(75);
				}
				this.setValue(_("custom PID Controller, please choose a other controller"));
                this.ctrlAutoselectHelp.setVisible(false);
				return;
			}
			if (this.getValue() == BaseModeDefinitions.Manual) {
				this.referenceZoneID.setVisible(false);
                this.ctrlOffset.getChildByElement('offsetNumber').allowBlank=true;
				this.ctrlOffset.setVisible(false);
                this.emergenyValue.getChildByElement('emergencyNumber').allowBlank=false;
				this.emergenyValue.setVisible(true);
				if (this.zoneID != null) {
					var selectedZone = this.zoneID.getValue();
					var emergencyValue = getEmergencyValueForZone(selectedZone);
					this.emergenyValue.setValue(emergencyValue);
				} else {
					this.emergenyValue.setValue(75);
				}
				this.setValue(_("manual Mode, please choose a other controller"));
                this.ctrlAutoselectHelp.setVisible(false);
				return;
			}
			if (this.getValue() == BaseModeDefinitions.AutoPID) {
				this.referenceZoneID.setVisible(false);
                this.ctrlOffset.getChildByElement('offsetNumber').allowBlank=true;
				this.ctrlOffset.setVisible(false);
                this.emergenyValue.getChildByElement('emergencyNumber').allowBlank=false;
				this.emergenyValue.setVisible(true);
				if (this.zoneID != null) {
					var selectedZone = this.zoneID.getValue();
					var emergencyValue = getEmergencyValueForZone(selectedZone);
					this.emergenyValue.setValue(emergencyValue);
				} else {
					this.emergenyValue.setValue(75);
				}
//this.setValue(_("Automatic controller configuration"));
                this.ctrlAutoselectHelp.setVisible(true);
				return;
			}
			if ((this.getValue() == BaseModeDefinitions.AutoFailed) ||
			    (this.getValue() == BaseModeDefinitions.AutoNoValves) ||
			    (this.getValue() == BaseModeDefinitions.AutoNoSensor) ||
			    (this.getValue() == BaseModeDefinitions.AutoNoController)) {
				this.referenceZoneID.setVisible(false);
				this.ctrlOffset.getChildByElement('offsetNumber').allowBlank=true;
				this.ctrlOffset.setVisible(false);
				this.emergenyValue.getChildByElement('emergencyNumber').allowBlank=false;
				this.emergenyValue.setVisible(true);
				var returnString = _('automatic mode');
				var oRecord = HeatingControl.heatingStore_controllerMode.findRecord('id', 0);
				if (oRecord) {
					returnString += ' (';
					returnString += oRecord.get('name');
					returnString += ')';
				}
					this.setValue(returnString);
				this.ctrlAutoselectHelp.setVisible(true);
				return;
			}
			var oModeType =  this.cboCombo.getStore().findRecord('id', this.getValue()).get('object').controllerMode;
            this.referenceZoneID.cboCombo.allowBlank = true;
			if (oModeType == ControlModes.cControlModeZoneFollower) {
                this.referenceZoneID.cboCombo.allowBlank = false;
				this.referenceZoneID.setVisible(true);
                this.ctrlOffset.getChildByElement('offsetNumber').allowBlank=false;
				this.ctrlOffset.setVisible(true);
				if (this.ctrlOffset.getValue() == null)
					this.ctrlOffset.setValue(0);
				var selectedZone = this.zoneID.getValue();
                this.referenceZoneID.cboCombo.getStore().clearFilter(true);
                this.referenceZoneID.cboCombo.getStore().filter({
					filterFn : function(iItem) {
						if (('' + iItem.get('id')) == ('' + selectedZone))
							return false;
						if (me.zoneControlValues[iItem.get('id')] != null)
							if (me.zoneControlValues[iItem.get('id')].ControllerMode == ControlModes.cControlModeZoneFollower)
								return false;
						return true;
					}
				});
                this.emergenyValue.getChildByElement('emergencyNumber').allowBlank=false;
				this.emergenyValue.setVisible(true);
				if (this.zoneID != null) {
					var selectedZone = this.zoneID.getValue();
					var emergencyValue = getEmergencyValueForZone(selectedZone);
					this.emergenyValue.setValue(emergencyValue);
				} else {
					this.emergenyValue.setValue(75);
				}
                this.ctrlAutoselectHelp.setVisible(false);
			} else if (oModeType == ControlModes.cControlModeFixedValue) {
				this.referenceZoneID.setVisible(false);
                this.ctrlOffset.getChildByElement('offsetNumber').allowBlank=true;
				this.ctrlOffset.setVisible(false);
                this.emergenyValue.getChildByElement('emergencyNumber').allowBlank=true;
				this.emergenyValue.setVisible(false);	
                this.ctrlAutoselectHelp.setVisible(false);
			} else {
				this.referenceZoneID.setVisible(false);
                this.ctrlOffset.getChildByElement('offsetNumber').allowBlank=true;
				this.ctrlOffset.setVisible(false);
				if (oModeType == ControlModes.cControlModeOff) {
                    this.emergenyValue.getChildByElement('emergencyNumber').allowBlank=true;
					this.emergenyValue.setVisible(false);
                } else {
                    this.emergenyValue.getChildByElement('emergencyNumber').allowBlank=false;
					this.emergenyValue.setVisible(true);
					if (this.zoneID != null) {
						var selectedZone = this.zoneID.getValue();
						var emergencyValue = getEmergencyValueForZone(selectedZone);
						this.emergenyValue.setValue(emergencyValue);
					} else {
						this.emergenyValue.setValue(75);
					}
				}
                if (oModeType == ControlModes.cControlModeAutomatic) {
                    this.ctrlAutoselectHelp.setVisible(true);
                } else {
                    this.ctrlAutoselectHelp.setVisible(false);
                }
			}

		});
		roomPanel.editorWindow.editControls['baseMode'].referenceZoneID = roomPanel.editorWindow.editControls['referenceZone'];
		roomPanel.editorWindow.editControls['baseMode'].zoneID = roomPanel.editorWindow.editControls['zoneID'];
		roomPanel.editorWindow.editControls['baseMode'].ctrlOffset = roomPanel.editorWindow.editControls['ctrlOffset'];
		roomPanel.editorWindow.editControls['baseMode'].emergenyValue = roomPanel.editorWindow.editControls['emergenyValue'];
		roomPanel.editorWindow.editControls['baseMode'].ctrlAutoselectHelp = roomPanel.editorWindow.editControls['ctrlAutoselectHelp'];
        
		var referenceZoneID = roomPanel.editorWindow.editControls['referenceZone'];
		var zoneID = roomPanel.editorWindow.editControls['zoneID'];
    	
    	
	    Ext.apply(this,  {
			border : false,
			flex : 1,
			style : {
				padding : '10px'
			},
			layout : {
				type : 'vbox',
				align : 'left'
			},
			items : [ {
				flex : 0,
				height : 120,
				width : "100%",
				xtype : 'panel',
				border : false,
				items : [ {
					xtype : 'fieldset',
					style : {
						padding : '10px'
					},
					height : 114,
					title : _('General Settings'),
					items : [ {
						xtype : 'panel',
						layout : 'hbox',
						border : false,
						items : [ this.radioHeatingAppGeneralSwitch ]
					}, {
						xtype : 'panel',
						layout : 'hbox',
						border : false,
						items : [ this.radioSingleMultihouse ]
					}, {
                        xtype : 'panel',
                        layout : 'hbox',
                        border : false,
                        items : [ this.radioHeatingSystemCapabilities ]
                    } ]
				} ]
			}, {
				flex : 1,
				xtype : 'fieldset',
				style : {
					padding : '10px'
				},
				layout : 'fit',
				reserveScrollbar : true,
				width : "100%",
				title : _('Roomsettings'),
				items : [ roomPanel ]
			} ]
		});
	    
		this.callParent(arguments);
		this.loadRoomParameter(this.roomPanel);
	}
});