Ext.define('DSS.component.myTemperatureControl', {
	extend : 'Ext.panel.Panel',
	myTemperatureControl : null,
	myValueControl : null,
	myTargetMode : null,
	myTemperatureLabel : null,
	myValueLabel : null,
	getHeight : function() {
		return 26;
	},
	constructor : function(config) {
		config.width = 700;
		config.border = false;
		this.myTargetMode = config.targetMode;

		var oBeginLabel = Ext.create('Ext.panel.Panel', {
			border : false,
			html : '<span style="color:#005138">' + config.label + ": </span>",
			width : 180
		});

		this.myTemperatureControl = Ext.create('Ext.form.field.Number', {
			labelWidth : 140,
			minValue : 3,
			maxValue : 35,
			step : 0.1,
			decimalSeparator : ',',
			decimalPrecision : 1,
            allowBlank : false,
			width : 60
		});

		this.myTemperatureLabel = Ext.create('Ext.panel.Panel', {
			padding : '2 0 0 5',
			border : false,
			html : '<span style="color:#005138">&deg;C</span>',
			width : 40
		});

		this.myValueControl = Ext.create('Ext.form.field.Number', {
			minValue : 0,
			maxValue : 100,
			step : 5,
			decimalPrecision : 0,
			width : 60
		});

		this.myValueLabel = Ext.create('Ext.panel.Panel', {
			padding : '2 0 0 5',
			border : false,
			html : '<span style="color:#005138">%</span>',
			width : 40
		});

        this.modeDescription = Ext.create('Ext.form.field.Display', {
            border : 0,
            height:18,
            flex:1,
            // width : 800,
            value : config.description
        });
        
		Ext.apply(this, {
			padding : '2 0 0 0',
			layout : 'hbox',
			height : 24,
			items : [ oBeginLabel, this.myTemperatureControl, this.myTemperatureLabel, this.myValueControl, this.myValueLabel, this.modeDescription ]
		});
		this.callParent(arguments);
	},
	reset : function() {
		var me = this;

		if (this.dssEditor.editControls['controlMode'].getValue() == 1) {
			this.myTemperatureLabel.setVisible(true);
			this.myTemperatureControl.setVisible(true);
			this.myTemperatureControl.setValue(null);
			this.myValueLabel.setVisible(false);
			this.myValueControl.setVisible(false);
			this.myValueControl.setValue(null);
		} else {
			this.myTemperatureLabel.setVisible(false);
			this.myTemperatureControl.setVisible(false);
			this.myTemperatureControl.setValue(null);
			this.myValueLabel.setVisible(true);
			this.myValueControl.setVisible(true);
			this.myValueControl.setValue(null);
		}
	},
	setValue : function(value) {
		var me = this;

		if (this.dssEditor.editControls['controlMode'].getValue() == 1) {
			this.myTemperatureLabel.setVisible(true);
			this.myTemperatureControl.setVisible(true);
			this.myTemperatureControl.setValue(value);
			this.myValueLabel.setVisible(false);
			this.myValueControl.setVisible(false);
			this.myValueControl.setValue(null);
		} else {
			this.myTemperatureLabel.setVisible(false);
			this.myTemperatureControl.setVisible(false);
			this.myTemperatureControl.setValue(null);
			this.myValueLabel.setVisible(true);
			this.myValueControl.setVisible(true);
			this.myValueControl.setValue(value);
		}

	},
	isValid : function() {
		var me = this;
		if (this.dssEditor.editControls['controlMode'].getValue() == 1)
			return this.myTemperatureControl.isValid();
		else
			return this.myValueControl.isValid();
	},
	getValue : function() {
		var me = this;

		if (this.dssEditor.editControls['controlMode'].getValue() == 1) {
			return this.myTemperatureControl.getValue();
		} else {
			return this.myValueControl.getValue();
		}
	}
});