Ext.define('DSS.component.TimePanel', {
	extend : 'Ext.panel.Panel',
    mixins : {
        observable : 'Ext.util.Observable'
    },
    basePanel:null,
    
    timeZoneEditor:null,
    timeNightEditor:null, 
    newNightButton:null,
    timeApartmentEditor:null,
    
	notUsedWeek:null,
	timeNightValues : {},
	timeStore:null,
	timeValues : null,
	getTimeString : function(v, fSeconds) {
		if (fSeconds == null)
			fSeconds = false;
		var sString = "";
		switch (Math.floor(v / (86400)) % 7) {
		case 0:
			sString += _("monday");
			break;
		case 1:
			sString += _("tuesday");
			break;
		case 2:
			sString += _("wednesday");
			break;
		case 3:
			sString += _("thursday");
			break;
		case 4:
			sString += _("friday");
			break;
		case 5:
			sString += _("saturday");
			break;
		case 6:
			sString += _("sunday");
			break;
		}
		sString += ", " + Math.floor(v / (3600)) % 24;
		sString += ":" + pad(Math.floor(v / (60)) % 60);
		if (fSeconds)
			sString += ":" + pad(Math.floor(v) % 60);
		return sString;
	},

	updateTimeStore : function() {
		var me = this;
		var nightValue = [];
		var startMonday = 0;

		if (this.timeNightValues['SU'] != null) {
			if (this.timeNightValues['SU'].to<(Time.HOURS_12)) {
				startMonday = this.timeNightValues['SU'].to;
				if (this.timeNightValues['SU'].from<(Time.HOURS_12)) {
					nightValue.push({
						duration : this.timeNightValues['SU'].from,
						type : OperationModes.nothing
					});
					startMonday-=this.timeNightValues['SU'].from;
				}												
				nightValue.push({
					duration : startMonday,
					type : OperationModes.Night
				});
				startMonday = this.timeNightValues['SU'].to;						
			}
		}

		if (this.timeNightValues['MO'] != null) {
			var diffTime = this.timeNightValues['MO'].from - startMonday;
			if (this.timeNightValues['MO'].from <(Time.HOURS_12))
					diffTime+=Time.DAY;
			nightValue.push({
				duration : diffTime,
				type : OperationModes.nothing
			});
			
			if (this.timeNightValues['MO'].to>this.timeNightValues['MO'].from) {
				diffTime = (this.timeNightValues['MO'].to  - this.timeNightValues['MO'].from);
			} else {
				diffTime = ((this.timeNightValues['MO'].to) + ((Time.DAY) - this.timeNightValues['MO'].from));
			}
			
			
			nightValue.push({
				duration : diffTime,
				type : OperationModes.Night
			});
			startMonday = this.timeNightValues['MO'].to + (Time.DAY);
			if (this.timeNightValues['MO'].to>(Time.HOURS_12))
				startMonday-=(Time.DAY);
		}

		if (this.timeNightValues['TU'] != null) {
			var diffTime = (this.timeNightValues['TU'].from + (Time.DAY)) - startMonday;
			if (this.timeNightValues['TU'].from <(Time.HOURS_12))
					diffTime+=Time.DAY;
			nightValue.push({
				duration : diffTime,
				type : OperationModes.nothing
			});

			if (this.timeNightValues['TU'].to>this.timeNightValues['TU'].from) {
				diffTime = (this.timeNightValues['TU'].to  - this.timeNightValues['TU'].from);
			} else {
				diffTime = ((this.timeNightValues['TU'].to) + ((Time.DAY) - this.timeNightValues['TU'].from));
			}

			nightValue.push({
				duration : diffTime,
				type : OperationModes.Night
			});
			startMonday = this.timeNightValues['TU'].to + (2 * Time.DAY);
			if (this.timeNightValues['TU'].to>(Time.HOURS_12))
				startMonday-=(Time.DAY);
		}

		if (this.timeNightValues['WE'] != null) {
			var diffTime = (this.timeNightValues['WE'].from + 2 * Time.DAY) - startMonday;
			if (this.timeNightValues['WE'].from <(Time.HOURS_12))
				diffTime+=Time.DAY;
			nightValue.push({
				duration : diffTime,
				type : OperationModes.nothing
			});

			if (this.timeNightValues['WE'].to>this.timeNightValues['WE'].from) {
				diffTime = (this.timeNightValues['WE'].to  - this.timeNightValues['WE'].from);
			} else {
				diffTime = ((this.timeNightValues['WE'].to) + ((Time.DAY) - this.timeNightValues['WE'].from));
			}

			nightValue.push({
				duration : diffTime,
				type : OperationModes.Night
			});
			startMonday = this.timeNightValues['WE'].to + (3 * Time.DAY);
			if (this.timeNightValues['WE'].to>(Time.HOURS_12))
				startMonday-=(Time.DAY);
		}

		if (this.timeNightValues['TH'] != null) {
			var diffTime = (this.timeNightValues['TH'].from + 3 * Time.DAY) - startMonday;
			if (this.timeNightValues['TH'].from <(Time.HOURS_12))
				diffTime+=Time.DAY;

			nightValue.push({
				duration : diffTime,
				type : OperationModes.nothing
			});
			
			if (this.timeNightValues['TH'].to>this.timeNightValues['TH'].from) {
				diffTime = (this.timeNightValues['TH'].to  - this.timeNightValues['TH'].from);
			} else {
				diffTime = ((this.timeNightValues['TH'].to) + ((Time.DAY) - this.timeNightValues['TH'].from));
			}
			
			nightValue.push({
				duration : diffTime,
				type : OperationModes.Night
			});
			startMonday = this.timeNightValues['TH'].to + (4 * Time.DAY);
			if (this.timeNightValues['TH'].to>(Time.HOURS_12))
				startMonday-=(Time.DAY);
		}

		if (this.timeNightValues['FR'] != null) {
			var diffTime = (this.timeNightValues['FR'].from + 4 * Time.DAY) - startMonday;
			if (this.timeNightValues['FR'].from <(Time.HOURS_12))
				diffTime+=Time.DAY;

			nightValue.push({
				duration : diffTime,
				type : OperationModes.nothing
			});

			if (this.timeNightValues['FR'].to>this.timeNightValues['FR'].from) {
				diffTime = (this.timeNightValues['FR'].to  - this.timeNightValues['FR'].from);
			} else {
				diffTime = ((this.timeNightValues['FR'].to) + ((Time.DAY) - this.timeNightValues['FR'].from));
			}
			
			nightValue.push({
				duration : diffTime,
				type : OperationModes.Night
			});
			startMonday = this.timeNightValues['FR'].to + (5 * Time.DAY);
			if (this.timeNightValues['FR'].to>(Time.HOURS_12))
				startMonday-=(Time.DAY);
		}

		if (this.timeNightValues['SA'] != null) {
			var diffTime = (this.timeNightValues['SA'].from + 5 * Time.DAY) - startMonday;
			if (this.timeNightValues['SA'].from <(Time.HOURS_12))
				diffTime+=Time.DAY;

			nightValue.push({
				duration : diffTime,
				type : OperationModes.nothing
			});

			if (this.timeNightValues['SA'].to>this.timeNightValues['SA'].from) {
				diffTime = (this.timeNightValues['SA'].to  - this.timeNightValues['SA'].from);
			} else {
				diffTime = ((this.timeNightValues['SA'].to) + ((Time.DAY) - this.timeNightValues['SA'].from));
			}

			nightValue.push({
				duration : diffTime,
				type : OperationModes.Night
			});
			startMonday = this.timeNightValues['SA'].to + (6 * Time.DAY);
			if (this.timeNightValues['SA'].to>(Time.HOURS_12))
				startMonday-=(Time.DAY);
		}

		if (this.timeNightValues['SU'] != null) {
			if (this.timeNightValues['SU'].from>(Time.HOURS_12)) {
				var diffTime = (this.timeNightValues['SU'].from + 6 * Time.DAY) - startMonday;

				nightValue.push({
					duration : diffTime,
					type : OperationModes.nothing
				});
				
				startMonday+=diffTime;
				
				if (this.timeNightValues['SU'].to>this.timeNightValues['SU'].from) {
					diffTime = (this.timeNightValues['SU'].to  - this.timeNightValues['SU'].from);
				} else {
					diffTime = ((this.timeNightValues['SU'].to) + ((Time.DAY) - this.timeNightValues['SU'].from));
				}

				if (startMonday+diffTime>(7 * Time.DAY))
					diffTime=(7 * Time.DAY)-startMonday;

				nightValue.push({
					duration : diffTime,
					type : OperationModes.Night
				});

				if (this.timeNightValues['SU'].to>(Time.HOURS_12)) {
					nightValue.push({
						duration : ((7 * Time.DAY) - startMonday-diffTime),
						type : OperationModes.nothing
					});
				}
            } else {
                nightValue.push({
                    duration : ((7 * Time.DAY) - startMonday),
                    type : OperationModes.nothing
                });
            }
            startMonday = (7 * Time.DAY);
        }
        nightValue.push({
				duration : ((7 * Time.DAY) - startMonday),
				type : OperationModes.nothing
			});


		this.timeValues.push({
			name : _('Night Mode'),
			id : -1,
			val : nightValue
		});
	
		var maxValues = 0;
		for ( var iIndex = 0; iIndex < this.timeValues.length; iIndex++) {
			var timeSeries = this.timeValues[iIndex];
			if (timeSeries.val.length > maxValues)
				maxValues = timeSeries.val.length;
		}
		var fields = [ 'label', 'zoneID' ];
		var fields2 = [];
		for ( var iIndex = 0; iIndex < maxValues; iIndex++) {
			fields.push('val' + iIndex);
			fields.push('typ' + iIndex);
			fields.push('tID' + iIndex);
			fields2.push('val' + iIndex);
		}

		var data = [];
		for ( var iIndex = 0; iIndex < this.timeValues.length; iIndex++) {
			var dateObject = {
				'label' : this.timeValues[iIndex].name,
				'zoneID' : this.timeValues[iIndex].id
			};
			var timeSeries = this.timeValues[iIndex];
			var kIndex = 0;
			for (; kIndex < timeSeries.val.length; kIndex++) {
				dateObject['val' + kIndex] = timeSeries.val[kIndex].duration;
				dateObject['typ' + kIndex] = timeSeries.val[kIndex].type;
				dateObject['tID' + kIndex] = timeSeries.val[kIndex].id;
			}
			for (; kIndex < maxValues; kIndex++) {
				dateObject['val' + kIndex] = 0;
				dateObject['typ' + kIndex] = -1;
			}
			data.push(dateObject);
		}
		if (me.timeStore == null) {
			me.timeStore = Ext.create('Ext.data.Store', {
				fields : fields,
				data : data,
				sorters : [ {
					sorterFn : function(o1, o2) {
						var iSort1 = o1.get('zoneID');
						var iSort2 = o2.get('zoneID');
						if (iSort1 == 0) {
							return 1;
						}
						if (iSort2 == 0) {
							return -1;
						}
						if (iSort1 == -1) {
							if (iSort2 == 0)
								return -1;
							else
								return 1;
						}
						if (iSort2 == -1) {
							if (iSort1 == 0)
								return 1;
							else
								return -1;
						}
						return dss.staticDataModel.getNameForZone(iSort1) < dss.staticDataModel.getNameForZone(iSort2);
					}
				} ]
			});

			var chart = Ext.create('Ext.chart.Chart', {
				// animate : true,
				shadow : false,
				store : me.timeStore,
				axes : [ {
					type : 'Numeric',
					position : 'bottom',
					fields : fields2,
					title : false,
					grid : true,
					majorTickSteps : 7,
					minimum : 0,
					maximum : (7 * Time.DAY),
					label : {
						renderer : me.getTimeString
					}
				}, {
					type : 'Category',
					position : 'left',
					fields : [ 'label' ],
					title : false
				} ],
				series : [ {
					type : 'bar',
					axis : 'bottom',
					gutter : 80,
					xField : 'room',
					yField : fields2,
					stacked : true,
					renderer : function(sprite, record, attributes, index, store) {
						return attributes;
					},
					tips : {
						trackMouse : true,
						width : 300,
						height : 35,
						layout : {
							type : 'hbox',
							align : 'left'
						},
						renderer : function(storeItem, item) {
							var baseIndex = parseInt(item.yField.substr(3), 10);
							var iStarttime = 0;
							for ( var iIndex = 0; iIndex < baseIndex; iIndex++) {
								iStarttime += storeItem.data['val' + iIndex];
							}
							var iStoptime = iStarttime + item.value[1];
							var typ = storeItem.get('typ' + baseIndex);
							var sModeString = "";
							switch (typ) {
							case OperationModes.transparent:
							case OperationModes.nothing:
								sModeString = _('(inactive - apartmentwide mode is active)');
								break;
							case OperationModes.Comfort:
								sModeString = _('Comfort Mode');
								break;
							case OperationModes.Eco:
								sModeString = _('Eco Mode');
								break;
							case OperationModes.NotUsed:
								sModeString = _('NotUsed Mode');
								break;
							case OperationModes.Night:
								sModeString = _('Night Mode');
								break;
							}
							this.setTitle(_('Mode:') + ' ' + sModeString + '<br>' + me.getTimeString(iStarttime) + " - " + me.getTimeString(iStoptime));
						}
					},
					listeners : {
						itemmousedown : function(evtObject) {
							var oRecord = evtObject.storeItem;
							var oItem = evtObject.yField;
							var itemIndex = oItem.substr(3);
							var iZoneID = oRecord.get('zoneID');
							if (iZoneID == -1) {
								me.timeNightEditor.show();
								me.timeNightEditor.setValue(me.timeNightValues);
							}
							if (iZoneID == 0) {
								var iType = oRecord.get('typ' + itemIndex);
								if (iType == OperationModes.Eco) {
									// clicked on eco -> new Comfort
									// zone
									me.timeApartmentEditor.setValue({
										from : null,
										fromID : null,
										to : null,
										toID : null
									});
									me.timeApartmentEditor.show();
								} else {
									var iStart = 0;
									var iEnd = 0;
									for ( var iIndex = 0; iIndex < parseInt(itemIndex, 10); iIndex++) {
										iStart += oRecord.get('val' + iIndex);
									}
									iEnd = iStart + oRecord.get(oItem);
									me.timeApartmentEditor.setValue({
										from : iStart,
										fromID : oRecord.get('tID' + parseInt(itemIndex, 10)),
										to : iEnd,
										toID : oRecord.get('tID' + (parseInt(itemIndex, 10) + 1))
									});
									me.timeApartmentEditor.show();
								}
							}
							if (iZoneID > 0) {
								
								me.timeZoneEditor.setValue(iZoneID);
								me.timeZoneEditor.show();

							}
						}
					}
				} ]
			});

			return chart;
		} else {
			var chart = me.items.items[0];
			me.timeStore.removeAll();
			me.timeStore.model.setFields(fields);
			var series = chart.series.first();
			series.yField = fields2;
			me.timeStore.add(data);		
		}
	},

	removeApartmentTime : function(value) {
		dss.raiseEvent('heating-controller.time-profile', {
			actions : 'delete',
			id : Ext.JSON.encode([ value.fromID, value.toID ])
		});
		this.waitAndReloadTimedSettings();
	},
	saveZoneTime : function(value) {
		if (value.zoneID == null)
			return;
		var fromWD = "";
		var toWD = "";

		switch (Math.floor(value.from / (Time.DAY))) {
		case 0:
			fromWD = "MO";
			break;
		case 1:
			fromWD = "TU";
			break;
		case 2:
			fromWD = "WE";
			break;
		case 3:
			fromWD = "TH";
			break;
		case 4:
			fromWD = "FR";
			break;
		case 5:
			fromWD = "SA";
			break;
		case 6:
			fromWD = "SU";
			break;
		}
		;
		switch (Math.floor(value.to / (Time.DAY))) {
		case 0:
			toWD = "MO";
			break;
		case 1:
			toWD = "TU";
			break;
		case 2:
			toWD = "WE";
			break;
		case 3:
			toWD = "TH";
			break;
		case 4:
			toWD = "FR";
			break;
		case 5:
			toWD = "SA";
			break;
		case 6:
			toWD = "SU";
			break;
		}
		;

		var oParameter = [ {
			id : value.fromID,
			desiredMode : OperationModes.NotUsed,
			target : value.zoneID,
			time : {
				offset : (value.from % (Time.DAY)),
				timeBase : 'daily'
			},
			recurrence : {
				recurrenceBase : 'weekly',
				recurrenceOffset : fromWD
			}
		}, {
			id : value.toID,
			resetingMode : OperationModes.NotUsed,
			target : value.zoneID,
			time : {
				offset : (value.to % (Time.DAY)),
				timeBase : 'daily'
			},
			recurrence : {
				recurrenceBase : 'weekly',
				recurrenceOffset : toWD
			}
		} ];
		if (oParameter.length > 0) {
			dss.raiseEvent('heating-controller.time-profile', {
				actions : 'save',
				value : Ext.JSON.encode(oParameter)
			});
			this.waitAndReloadTimedSettings();
		}
	},
	removeTimeline : function(zoneID) {
		dss.raiseEvent('heating-controller.time-profile', {
			actions : 'deleteTimeline',
			zoneID : zoneID
		});
		this.waitAndReloadTimedSettings();
	},
	removeZoneTime : function(value) {
		dss.raiseEvent('heating-controller.time-profile', {
			actions : 'delete',
			id : Ext.JSON.encode([ value.fromID, value.toID ])
		});
		this.waitAndReloadTimedSettings();
	},
	saveApartmentTime : function(value) {
		var fromWD = "";
		var toWD = "";
		switch (Math.floor(value.from / (Time.DAY))) {
		case 0:
			fromWD = "MO";
			break;
		case 1:
			fromWD = "TU";
			break;
		case 2:
			fromWD = "WE";
			break;
		case 3:
			fromWD = "TH";
			break;
		case 4:
			fromWD = "FR";
			break;
		case 5:
			fromWD = "SA";
			break;
		case 6:
			fromWD = "SU";
			break;
		}
		;
		switch (Math.floor(value.to / (Time.DAY))) {
		case 0:
			toWD = "MO";
			break;
		case 1:
			toWD = "TU";
			break;
		case 2:
			toWD = "WE";
			break;
		case 3:
			toWD = "TH";
			break;
		case 4:
			toWD = "FR";
			break;
		case 5:
			toWD = "SA";
			break;
		case 6:
			toWD = "SU";
			break;
		}
		;

		var oParameter = [ {
			id : value.fromID,
			desiredMode : OperationModes.Comfort,
			target : 0,
			time : {
				offset : (value.from % (Time.DAY)),
				timeBase : 'daily'
			},
			recurrence : {
				recurrenceBase : 'weekly',
				recurrenceOffset : fromWD
			}
		}, {
			id : value.toID,
			desiredMode : OperationModes.Eco,
			target : 0,
			time : {
				offset : (value.to % (Time.DAY)),
				timeBase : 'daily'
			},
			recurrence : {
				recurrenceBase : 'weekly',
				recurrenceOffset : toWD
			}
		} ];
		if (oParameter.length > 0) {
			dss.raiseEvent('heating-controller.time-profile', {
				actions : 'save',
				value : Ext.JSON.encode(oParameter)
			});
			this.waitAndReloadTimedSettings();
		}
	},
	saveNightTime : function(value) {
		var oParameter = [];
		
		
		if (value.MO != null) {
			var dayFrom='MO';
			if (value.MO.from<Time.HOURS_12)
				dayFrom='TU';
			var dayTo='TU';
			if (value.MO.to>Time.HOURS_12)
				dayTo='MO';

			oParameter.push({
				id : value.MO.fromID,
				desiredMode : OperationModes.Night,
				target : 0,
				time : {
					offset : value.MO.from,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : dayFrom
				}
			});
			oParameter.push({
				id : value.MO.toID,
				resetingMode : OperationModes.Night,
				target : 0,
				time : {
					offset : value.MO.to,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : dayTo
				}
			});
		} else {
			oParameter.push({
				id : null,
				desiredMode : OperationModes.Night,
				target : 0,
				time : {
					offset : (Time.HOURS_12),
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : 'MO'
				},
				disabled:true
			});
			oParameter.push({
				id : null,
				resetingMode : OperationModes.Night,
				target : 0,
				time : {
					offset : (Time.HOURS_12)-1,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : 'TU'
				},
				disabled:true
			});
		}
		if (value.TU != null) {
			var dayFrom='TU';
			if (value.TU.from<Time.HOURS_12)
				dayFrom='WE';
			var dayTo='WE';
			if (value.TU.to>Time.HOURS_12)
				dayTo='TU';
			
			oParameter.push({
				id : value.TU.fromID,
				desiredMode : OperationModes.Night,
				target : 0,
				time : {
					offset : value.TU.from,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : dayFrom
				}
			});
			oParameter.push({
				id : value.TU.toID,
				resetingMode : OperationModes.Night,
				target : 0,
				time : {
					offset : value.TU.to,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : dayTo
				}
			});
		} else {
			oParameter.push({
				id : null,
				desiredMode : OperationModes.Night,
				target : 0,
				time : {
					offset : (Time.HOURS_12),
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : 'TU'
				},
				disabled:true
			});
			oParameter.push({
				id : null,
				resetingMode : OperationModes.Night,
				target : 0,
				time : {
					offset : (Time.HOURS_12)-1,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : 'WE'
				},
				disabled:true
			});
		}

		if (value.WE != null) {
			var dayFrom='WE';
			if (value.WE.from<Time.HOURS_12)
				dayFrom='TH';
			var dayTo='TH';
			if (value.WE.to>Time.HOURS_12)
				dayTo='WE';
			oParameter.push({
				id : value.WE.fromID,
				desiredMode : OperationModes.Night,
				target : 0,
				time : {
					offset : value.WE.from,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : dayFrom
				}
			});
			oParameter.push({
				id : value.WE.toID,
				resetingMode : OperationModes.Night,
				target : 0,
				time : {
					offset : value.WE.to,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : dayTo
				}
			});
		} else {
			oParameter.push({
				id : null,
				desiredMode : OperationModes.Night,
				target : 0,
				time : {
					offset : (Time.HOURS_12),
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : 'WE'
				},
				disabled:true
			});
			oParameter.push({
				id : null,
				resetingMode : OperationModes.Night,
				target : 0,
				time : {
					offset : (Time.HOURS_12)-1,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : 'TH'
				},
				disabled:true
			});
		}
		if (value.TH != null) {
			var dayFrom='TH';
			if (value.TH.from<Time.HOURS_12)
				dayFrom='FR';
			var dayTo='FR';
			if (value.TH.to>Time.HOURS_12)
				dayTo='TH';
			oParameter.push({
				id : value.TH.fromID,
				desiredMode : OperationModes.Night,
				target : 0,
				time : {
					offset : value.TH.from,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : dayFrom
				}
			});
			oParameter.push({
				id : value.TH.toID,
				resetingMode : OperationModes.Night,
				target : 0,
				time : {
					offset : value.TH.to,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : dayTo
				}
			});
		} else {
			oParameter.push({
				id : null,
				desiredMode : OperationModes.Night,
				target : 0,
				time : {
					offset : (Time.HOURS_12),
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : 'TH'
				},
				disabled:true
			});
			oParameter.push({
				id : null,
				resetingMode : OperationModes.Night,
				target : 0,
				time : {
					offset : (Time.HOURS_12)-1,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : 'FR'
				},
				disabled:true
			});
		}
		if (value.FR != null) {
			var dayFrom='FR';
			if (value.FR.from<Time.HOURS_12)
				dayFrom='SA';
			var dayTo='SA';
			if (value.FR.to>Time.HOURS_12)
				dayTo='FR';
			oParameter.push({
				id : value.FR.fromID,
				desiredMode : OperationModes.Night,
				target : 0,
				time : {
					offset : value.FR.from,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : dayFrom
				}
			});
			oParameter.push({
				id : value.FR.toID,
				resetingMode : OperationModes.Night,
				target : 0,
				time : {
					offset : value.FR.to,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : dayTo
				}
			});
		} else {
			oParameter.push({
				id : null,
				desiredMode : OperationModes.Night,
				target : 0,
				time : {
					offset : (Time.HOURS_12),
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : 'FR'
				},
				disabled:true
			});
			oParameter.push({
				id : null,
				resetingMode : OperationModes.Night,
				target : 0,
				time : {
					offset : (Time.HOURS_12)-1,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : 'SA'
				},
				disabled:true
			});
		}
		if (value.SA != null) {
			var dayFrom='SA';
			if (value.SA.from<Time.HOURS_12)
				dayFrom='SU';
			var dayTo='SU';
			if (value.SA.to>Time.HOURS_12)
				dayTo='SA';
			oParameter.push({
				id : value.SA.fromID,
				desiredMode : OperationModes.Night,
				target : 0,
				time : {
					offset : value.SA.from,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : dayFrom
				}
			});
			oParameter.push({
				id : value.SA.toID,
				resetingMode : OperationModes.Night,
				target : 0,
				time : {
					offset : value.SA.to,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : dayTo
				}
			});
		} else {
			oParameter.push({
				id : null,
				desiredMode : OperationModes.Night,
				target : 0,
				time : {
					offset : (Time.HOURS_12),
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : 'SA'
				},
				disabled:true
			});
			oParameter.push({
				id : null,
				resetingMode : OperationModes.Night,
				target : 0,
				time : {
					offset : (Time.HOURS_12)-1,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : 'SU'
				},
				disabled:true
			});
		}
		if (value.SU != null) {
			var dayFrom='SU';
			if (value.SU.from<Time.HOURS_12)
				dayFrom='MO';
			var dayTo='MO';
			if (value.SU.to>Time.HOURS_12)
				dayTo='SU';
			oParameter.push({
				id : value.SU.fromID,
				desiredMode : OperationModes.Night,
				target : 0,
				time : {
					offset : value.SU.from,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : dayFrom
				}
			});
			oParameter.push({
				id : value.SU.toID,
				resetingMode : OperationModes.Night,
				target : 0,
				time : {
					offset : value.SU.to,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : dayTo
				}
			});
		} else {
			oParameter.push({
				id : null,
				desiredMode : OperationModes.Night,
				target : 0,
				time : {
					offset : (Time.HOURS_12),
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : 'SU'
				},
				disabled:true
			});
			oParameter.push({
				id : null,
				resetingMode : OperationModes.Night,
				target : 0,
				time : {
					offset : (Time.HOURS_12)-1,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : 'MO'
				},
				disabled:true
			});
		}
		if (oParameter.length > 0) {
			dss.raiseEvent('heating-controller.time-profile', {
				actions : 'save',
				value : Ext.JSON.encode(oParameter)
			});
			this.waitAndReloadTimedSettings();
		}
	},
	saveSingularyTime : function(value) {
		var oParameter = [];
		var zoneID=value.zoneID;
		if (value.MO != null) {
			oParameter.push({
				id : value.MO.fromID,
				desiredMode : OperationModes.NotUsed,
				target : zoneID,
				time : {
					offset : value.MO.from,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : 'MO'
				}
			});
			oParameter.push({
				id : value.MO.toID,
				resetingMode : OperationModes.NotUsed,
				target : zoneID,
				time : {
					offset : value.MO.to,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : 'MO'
				}
			});
		} else {
			oParameter.push({
				id : null,
				desiredMode : OperationModes.NotUsed,
				target : zoneID,
				time : {
					offset : 0,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : 'MO'
				},
				disabled:true
			});
			oParameter.push({
				id : null,
				resetingMode : OperationModes.NotUsed,
				target : zoneID,
				time : {
					offset : (Time.DAY)-1,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : 'MO'
				},
				disabled:true
			});
		}
		if (value.TU != null) {
			oParameter.push({
				id : value.TU.fromID,
				desiredMode : OperationModes.NotUsed,
				target : zoneID,
				time : {
					offset : value.TU.from,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : 'TU'
				}
			});
			oParameter.push({
				id : value.TU.toID,
				resetingMode : OperationModes.NotUsed,
				target : zoneID,
				time : {
					offset : value.TU.to,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : 'TU'
				}
			});
		} else {
			oParameter.push({
				id : null,
				desiredMode : OperationModes.NotUsed,
				target : zoneID,
				time : {
					offset : 0,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : 'TU'
				},
				disabled:true
			});
			oParameter.push({
				id : null,
				resetingMode : OperationModes.NotUsed,
				target : zoneID,
				time : {
					offset : (Time.DAY)-1,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : 'TU'
				},
				disabled:true
			});
		}

		if (value.WE != null) {
			oParameter.push({
				id : value.WE.fromID,
				desiredMode : OperationModes.NotUsed,
				target : zoneID,
				time : {
					offset : value.WE.from,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : 'WE'
				}
			});
			oParameter.push({
				id : value.WE.toID,
				resetingMode : OperationModes.NotUsed,
				target : zoneID,
				time : {
					offset : value.WE.to,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : 'WE'
				}
			});
		} else {
			oParameter.push({
				id : null,
				desiredMode : OperationModes.NotUsed,
				target : zoneID,
				time : {
					offset : 0,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : 'WE'
				},
				disabled:true
			});
			oParameter.push({
				id : null,
				resetingMode : OperationModes.NotUsed,
				target : zoneID,
				time : {
					offset : (Time.DAY)-1,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : 'WE'
				},
				disabled:true
			});
		}

		if (value.TH != null) {
			oParameter.push({
				id : value.TH.fromID,
				desiredMode : OperationModes.NotUsed,
				target : zoneID,
				time : {
					offset : value.TH.from,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : 'TH'
				}
			});
			oParameter.push({
				id : value.TH.toID,
				resetingMode : OperationModes.NotUsed,
				target : zoneID,
				time : {
					offset : value.TH.to,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : 'TH'
				}
			});
		} else {
			oParameter.push({
				id : null,
				desiredMode : OperationModes.NotUsed,
				target : zoneID,
				time : {
					offset : 0,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : 'TH'
				},
				disabled:true
			});
			oParameter.push({
				id : null,
				resetingMode : OperationModes.NotUsed,
				target : zoneID,
				time : {
					offset : (Time.DAY)-1,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : 'TH'
				},
				disabled:true
			});
		}

		if (value.FR != null) {
			oParameter.push({
				id : value.FR.fromID,
				desiredMode : OperationModes.NotUsed,
				target : zoneID,
				time : {
					offset : value.FR.from,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : 'FR'
				}
			});
			oParameter.push({
				id : value.FR.toID,
				resetingMode : OperationModes.NotUsed,
				target : zoneID,
				time : {
					offset : value.FR.to,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : 'FR'
				}
			});
		} else {
			oParameter.push({
				id : null,
				desiredMode : OperationModes.NotUsed,
				target : zoneID,
				time : {
					offset : 0,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : 'FR'
				},
				disabled:true
			});
			oParameter.push({
				id : null,
				resetingMode : OperationModes.NotUsed,
				target : zoneID,
				time : {
					offset : (Time.DAY)-1,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : 'FR'
				},
				disabled:true
			});
		}

		if (value.SA != null) {
			oParameter.push({
				id : value.SA.fromID,
				desiredMode : OperationModes.NotUsed,
				target : zoneID,
				time : {
					offset : value.SA.from,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : 'SA'
				}
			});
			oParameter.push({
				id : value.SA.toID,
				resetingMode : OperationModes.NotUsed,
				target : zoneID,
				time : {
					offset : value.SA.to,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : 'SA'
				}
			});
		} else {
			oParameter.push({
				id : null,
				desiredMode : OperationModes.NotUsed,
				target : zoneID,
				time : {
					offset : 0,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : 'SA'
				},
				disabled:true
			});
			oParameter.push({
				id : null,
				resetingMode : OperationModes.NotUsed,
				target : zoneID,
				time : {
					offset : (Time.DAY)-1,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : 'SA'
				},
				disabled:true
			});
		}

		if (value.SU != null) {
			oParameter.push({
				id : value.SU.fromID,
				desiredMode : OperationModes.NotUsed,
				target : zoneID,
				time : {
					offset : value.SU.from,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : 'SU'
				}
			});
			oParameter.push({
				id : value.SU.toID,
				resetingMode : OperationModes.NotUsed,
				target : zoneID,
				time : {
					offset : value.SU.to,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : 'SU'
				}
			});
		} else {
			oParameter.push({
				id : null,
				desiredMode : OperationModes.NotUsed,
				target : zoneID,
				time : {
					offset : 0,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : 'SU'
				},
				disabled:true
			});
			oParameter.push({
				id : null,
				resetingMode : OperationModes.NotUsed,
				target : zoneID,
				time : {
					offset : (Time.DAY)-1,
					timeBase : 'daily'
				},
				recurrence : {
					recurrenceBase : 'weekly',
					recurrenceOffset : 'SU'
				},
				disabled:true
			});
		}

		if (oParameter.length > 0) {
			dss.raiseEvent('heating-controller.time-profile', {
				actions : 'deleteTimeline',
				zoneID : zoneID,
				noAnswer:true
			});
			dss.raiseEvent('heating-controller.time-profile', {
				actions : 'save',
				value : Ext.JSON.encode(oParameter)
			});
			this.waitAndReloadTimedSettings();
		}
	},	
	
	
	loadTimedSettings : function() {
		var sString = dss.ajaxSyncRequest('/json/property/query', {
			'query' : '/scripts/heating-controller/time-profile/*(*)/*(*)'
		});
		this.timeValues = [];
		this.timeNightValues = [];
		this.notUsedWeek ={};
		var oValues = {};
		try {
			var result = Ext.JSON.decode(sString);

			if (result.ok) {
				var res = result.result['time-profile'];
				for ( var iIndex = 0; iIndex < res.length; iIndex++) {
					if  (res[iIndex].disabled!=true) {
						var iTarget; // 0=apartment, -1 night, alles
										// andere zone
						if (res[iIndex].target == 0) {
							iTarget = 0;
							if (res[iIndex].desiredMode != null)
								if (res[iIndex].desiredMode == OperationModes.Night)
									iTarget = -1;
							if (res[iIndex].resetingMode != null)
								if (res[iIndex].resetingMode == OperationModes.Night)
									iTarget = -1;
						} else
							iTarget = res[iIndex].target;

						var iOffset = 0;
						var day = "";
						for ( var kIndex = 0; kIndex < res[iIndex][res[iIndex].id].length; kIndex++) {
							var oObject = res[iIndex][res[iIndex].id][kIndex];
							if (oObject.offset != null)
								iOffset = oObject.offset;
							if (oObject.recurrenceOffset != null)
								day = oObject.recurrenceOffset;
						}

						if (iTarget == -1) {
								
							if (res[iIndex].resetingMode != null) {
								if (iOffset<Time.HOURS_12) {
									if (day == "MO")
										day = "SU";
									else if (day == "TU")
										day = "MO";
									else if (day == "WE")
										day = "TU";
									else if (day == "TH")
										day = "WE";
									else if (day == "FR")
										day = "TH";
									else if (day == "SA")
										day = "FR";
									else if (day == "SU")
										day = "SA";
								}
								if (this.timeNightValues[day] == null)
									this.timeNightValues[day] = {};
								this.timeNightValues[day].to = iOffset;
								this.timeNightValues[day].toID = res[iIndex].id;
							} else {
								if (iOffset<Time.HOURS_12) {
									if (day == "MO")
										day = "SU";
									else if (day == "TU")
										day = "MO";
									else if (day == "WE")
										day = "TU";
									else if (day == "TH")
										day = "WE";
									else if (day == "FR")
										day = "TH";
									else if (day == "SA")
										day = "FR";
									else if (day == "SU")
										day = "SA";
								}

								
								if (this.timeNightValues[day] == null)
									this.timeNightValues[day] = {};
								this.timeNightValues[day].from = iOffset;
								this.timeNightValues[day].fromID = res[iIndex].id;
							}

						} else if (iTarget > 0) {									

							
							if (this.notUsedWeek[iTarget]==null)
								this.notUsedWeek[iTarget]={};
							if (this.notUsedWeek[iTarget][day]==null)
								this.notUsedWeek[iTarget][day]={};

							if (res[iIndex].resetingMode != null) {
								this.notUsedWeek[iTarget][day].to=iOffset;
								this.notUsedWeek[iTarget][day].toID=res[iIndex].id;
							} else {
								this.notUsedWeek[iTarget][day].from=iOffset;
								this.notUsedWeek[iTarget][day].fromID=res[iIndex].id;
							}

							
							if (oValues['' + iTarget] == null)
								oValues['' + iTarget] = [];
							switch (day) {
							case 'MO':
								iOffset += (0 * Time.DAY);
								break;
							case 'TU':
								iOffset += (1 * Time.DAY);
								break;
							case 'WE':
								iOffset += (2 * Time.DAY);
								break;
							case 'TH':
								iOffset += (3 * Time.DAY);
								break;
							case 'FR':
								iOffset += (4 * Time.DAY);
								break;
							case 'SA':
								iOffset += (5 * Time.DAY);
								break;
							case 'SU':
								iOffset += (6 * Time.DAY);
								break;
							}
							if (iTarget != 0)
								if (res[iIndex].resetingMode != null)
									if (res[iIndex].resetingMode == OperationModes.NotUsed)
										res[iIndex].desiredMode = OperationModes.transparent;
							
							
								
							oValues['' + iTarget].push({
								time : iOffset,
								mode : res[iIndex].desiredMode,
								id : res[iIndex].id
							});
							/*
							 * { duration : 21600, type : 2 },
							 */
						}
					}
				}
			}

		} catch (e) {

		}
		/*
		 * if (oValues['0'] == 0) oValues['0'] = [ { time : 0, mode :
		 * OperationModes.Eco, id : null } ];
		 */
		for ( var sKey in oValues) {
			var oValue = oValues[sKey];
			oValue.sort(function(a, b) {
				return a.time - b.time;
			});
			var timeIndex = 0;
			var val = [];
			if (oValue.length > 0) {
				if (oValue[0].time != 0) {
					var oObject = {
						duration : oValue[0].time,
						type : oValue[oValue.length - 1].mode,
						id : oValue[oValue.length - 1].id
					};
					val.push(oObject);
				}
				timeIndex = oValue[0].time;
				for ( var iIndex = 0; iIndex < oValue.length - 1; iIndex++) {
					var oObject = {
						duration : (oValue[iIndex + 1].time - timeIndex),
						type : oValue[iIndex].mode,
						id : oValue[iIndex].id
					};
					val.push(oObject);
					timeIndex = oValue[iIndex + 1].time;
				}

				var oObject = {
					duration : ((7 * Time.DAY) - timeIndex),
					type : oValue[oValue.length - 1].mode,
					id : oValue[oValue.length - 1].id
				};
				val.push(oObject);
			}
			var zoneID = parseInt(sKey, 10);
			var oValueObjectForChart = {
				name : (zoneID == 0) ? _('Apartment') : dss.staticDataModel.getNameForZone(zoneID),
				id : zoneID,
				val : val
			};
			this.timeValues.push(oValueObjectForChart);
		}
        /*
		 * if no time profile for a usable zone found add an empty one
		 * in the graph
		 */
		for ( var iIndex = 0; iIndex < this.basePanel.usableZones.length; iIndex++) {
			var oZoneObject = this.basePanel.usableZones[iIndex];
			var fFound = false;
			for ( var jIndex = 0; jIndex < this.timeValues.length; jIndex++) {
				if (this.timeValues[jIndex].id == oZoneObject.ZoneID)
					fFound = true;
			}
			if (!fFound) {
				this.timeValues.push({
					name : oZoneObject.name,
					id : oZoneObject.ZoneID,
					val : [ {
						duration : 604800,
						type : -1
					} ]
				});
            }
		}
        /* remove time profile for a not usable zone */
        for ( var jIndex = 0; jIndex < this.timeValues.length; jIndex++) {
			var fFound = false;
			for ( var iIndex = 0; iIndex < this.basePanel.usableZones.length; iIndex++) {
				var oZoneObject = this.basePanel.usableZones[iIndex];
				if (this.timeValues[jIndex].id == oZoneObject.ZoneID)
					fFound = true;
			}
			if (!fFound) {
                this.removeTimeline(this.timeValues[jIndex].id);
				this.timeValues.splice(jIndex,1);
            }
		}
        
	},
	waitAndReloadTimedSettings : function() {
		var me = this;
		var iSubscriptID = Math.floor(Math.random() * 100000000000);
		dss.ajaxSyncRequest('/json/event/subscribe', {
			subscriptionID : iSubscriptID,
			name : 'heating-controller.answer'
		});
		dss.ajaxAssyncRequestWithoutAnswer('/json/event/get', {
			subscriptionID : iSubscriptID,
			timeout : 60 * 1000
		}, function() {
			me.loadTimedSettings();
			dss.ajaxAssyncRequestWithoutAnswer('/json/event/unsubscribe', {
				subscriptionID : iSubscriptID,
				name : 'heating-controller.answer'
			});
			me.updateTimeStore();
		});
	},
	
    constructor : function(config) {
    	this.basePanel=config.basePanel;
    	
    	var me = this;
		me.timeNightEditor = Ext.create('DSS.addon.TimeNightEditor',
										{ base: me });
		// me.timeNightEditor.base = me;
		me.timeApartmentEditor = Ext.create('DSS.addon.TimeApartmentEditor', {});
		me.timeApartmentEditor.base = me;
		me.timeZoneEditor = Ext.create('DSS.addon.SingularZoneEditor',
										{ base: me });

		me.loadTimedSettings();

		/*
		 * var newApartmentButton = Ext.create('Ext.button.Button', {
		 * text : _('Define new Comfort period'), iconCls :
		 * 'icon-add-action', handler : function() {
		 * me.timeApartmentEditor.setValue({ from : null, fromID : null,
		 * to : null, toID : null }); me.timeApartmentEditor.show(); } })
		 */;
		me.newNightButton = Ext.create('Ext.button.Button', {
			text : _('Define Night period'),
			iconCls : 'icon-add-action',
			handler : function() {
				me.timeNightEditor.show();
				me.timeNightEditor.setValue(me.timeNightValues);
			}
		});
		var newRoomButton = new Ext.create('Ext.button.Button', {
			text : _('Define new unused period'),
			iconCls : 'icon-add-action',
			handler : function() {
				me.timeZoneEditor.setValue(null);
				me.timeZoneEditor.show();
			}
		});

		var refreshButton= new Ext.create('Ext.button.Button',{
			text:_('Refresh'),
			handler: function(){
				me.loadTimedSettings();
				me.updateTimeStore();
			},
			icon: dss.staticDataModel.baseImagePath + 'buttonIcons/refresh.png'
		});
		    	
	    Ext.apply(this, {
			layout : 'fit',
			tbar : [ me.newNightButton, ' ', newRoomButton ],
			bbar : ['->' , refreshButton],
			items:[this.updateTimeStore()]
		});
		
		this.callParent(arguments);

    }
});