Ext.define('DSS.component.VentilationPanel', {
	extend : 'Ext.panel.Panel',
    mixins : {
        observable : 'Ext.util.Observable'
    },
    ventilationManual:null,
    ventilationLevelAvaible:null,
    ventilationOutputDevices:null,
    ventilationMalfunctionSensors:null,
	ventilationServiceSensors:null,
	ventilationSettingNormalLevel:null,
	ventilationSettingAbsentEnabler:null,
	ventilationSettingAbsentLevel:null,
	ventilationSettingBoostEnabler:null,
	ventilationSettingBoostTime:null,
	ventilationSettingHumidityExtendedEnabler:null,
	ventilationSettingHumidityExtendedLimit:null,
    
	filterDevice: function(device) {
		if (!device.present)
			return false;
		if (device.outputMode==0)
			return false;
		for (var iIndex=0;iIndex<device.GroupMembership.length;iIndex++)
			if (device.GroupMembership[iIndex]==64)
				return true;
		return false;
	},
	
	loadPanel: function () {		
		
		var sString = dss.ajaxSyncRequest('/json/property/query2', {
			'query' : '/scripts/heating-controller/apartmentVentilation(*)'
		});
		try {
			var fUbndwem=false;
			var result = Ext.JSON.decode(sString);
			if (result.result!=null)
				if (result.result.apartmentVentilation!=null) {
					if (result.result.apartmentVentilation.nominalLevel!=null) {
						this.ventilationSettingNormalLevel.suspendEvents();
						this.ventilationSettingNormalLevel.setValue(result.result.apartmentVentilation.nominalLevel);
						this.ventilationSettingNormalLevel.resumeEvents();
					}
					if (result.result.apartmentVentilation.absentLevel!=null) {
						this.ventilationSettingAbsentLevel.suspendEvents();
						this.ventilationSettingAbsentEnabler.suspendEvents();
						this.ventilationSettingAbsentEnabler.setValue(true);
						this.ventilationSettingAbsentLevel.setValue(result.result.apartmentVentilation.absentLevel);
						this.ventilationSettingAbsentLevel.resumeEvents();
						this.ventilationSettingAbsentEnabler.resumeEvents();
					} else {
						this.ventilationSettingAbsentEnabler.suspendEvents();
						this.ventilationSettingAbsentEnabler.setValue(false);
						this.ventilationSettingAbsentEnabler.resumeEvents();
					}
					if (result.result.apartmentVentilation.ubndwem!=null) {
						this.ventilationSettingBoostEnabler.suspendEvents();
						this.ventilationSettingBoostEnabler.setValue(false);
						if (result.result.apartmentVentilation.ubndwem){
							this.ventilationSettingBoostEnabler.setValue(true);
						}
						fUbndwem=result.result.apartmentVentilation.ubndwem;
						this.ventilationSettingBoostEnabler.resumeEvents();
					}
					if (result.result.apartmentVentilation.boostStopTime!=null) {
						this.ventilationSettingBoostTime.suspendEvents();
						this.ventilationSettingBoostTime.setValue(result.result.apartmentVentilation.boostStopTime);
						this.ventilationSettingBoostTime.resumeEvents();
					} else {
						this.ventilationSettingBoostTime.suspendEvents();
						this.ventilationSettingBoostTime.setValue(60*60);
						this.ventilationSettingBoostTime.resumeEvents();
					}
					if (result.result.apartmentVentilation.humidityLimit !=null) {
						this.ventilationSettingHumidityExtendedEnabler.suspendEvents();
						this.ventilationSettingHumidityExtendedLimit.suspendEvents();
						this.ventilationSettingHumidityExtendedEnabler.setValue(true);
						this.ventilationSettingHumidityExtendedLimit.setDisabled(false);
						this.ventilationSettingHumidityExtendedLimit.setValue(result.result.apartmentVentilation.humidityLimit );
						this.ventilationSettingHumidityExtendedLimit.resumeEvents();
						this.ventilationSettingHumidityExtendedEnabler.resumeEvents();
					} else {
						this.ventilationSettingHumidityExtendedEnabler.suspendEvents();
						this.ventilationSettingHumidityExtendedLimit.suspendEvents();
						this.ventilationSettingHumidityExtendedEnabler.setValue(false);
						this.ventilationSettingHumidityExtendedLimit.setDisabled(true);
						this.ventilationSettingHumidityExtendedLimit.resumeEvents();
						this.ventilationSettingHumidityExtendedEnabler.resumeEvents();
					}
				}
		} catch (e) {
			
		}
		
		var sString = dss.ajaxSyncRequest('/json/structure/groupGetConfiguration', {
			zoneID:0,
			groupID:64
		});
		this.ventilationLevelAvaible.suspendEvents();
		this.ventilationManual.suspendEvents();
		this.ventilationSettingNormalLevel.cboStore.clearFilter(true);

		var result = Ext.JSON.decode(sString);
		if (result.result.activeBasicScenes!=null) {
			if (result.result.activeBasicScenes.indexOf(0)!=-1) {
				this.ventilationManual.setValue({ventilationManual:true});
			} else {
				this.ventilationManual.setValue({ventilationManual:false});
			}
			var maxLevel=4;
			if (result.result.activeBasicScenes.indexOf(19)!=-1) {
				maxLevel=4;
			} else if (result.result.activeBasicScenes.indexOf(18)!=-1) {
				maxLevel=3;
				this.ventilationSettingNormalLevel.cboStore.filter([
		            {filterFn: function(item) { return item.get("id") < 4; }}
		        ]);
				this.ventilationSettingAbsentLevel.cboStore.filter([
		            {filterFn: function(item) { return item.get("id") < 4; }}
		        ]);
			} else if (result.result.activeBasicScenes.indexOf(17)!=-1) {
				maxLevel=2;
				this.ventilationSettingNormalLevel.cboStore.filter([
		            {filterFn: function(item) { return item.get("id") < 3; }}
		        ]);
				this.ventilationSettingAbsentLevel.cboStore.filter([
		            {filterFn: function(item) { return item.get("id") < 3; }}
		        ]);
			} else {
				maxLevel=1;
				this.ventilationSettingNormalLevel.cboStore.filter([
		            {filterFn: function(item) { return item.get("id") < 2; }}
		        ]);
				this.ventilationSettingAbsentLevel.cboStore.filter([
		            {filterFn: function(item) { return item.get("id") < 2; }}
		        ]);
			}
			this.ventilationLevelAvaible.setValue(maxLevel);
			if ((this.ventilationSettingBoostEnabler.getValue())&& (maxLevel<4)) {
				this.ventilationLevelAvaible.setValue(maxLevel+1);
			}
		} else {
			this.ventilationLevelAvaible.setValue(4);
			this.ventilationManual.setValue({ventilationManual:true});
		}
		
		this.ventilationLevelAvaible.resumeEvents();
		this.ventilationManual.resumeEvents();
		
		for (var iIndex=0;iIndex<dss.staticDataModel.deviceAKMCache.length;iIndex++) {
			var oDev=dss.staticDataModel.deviceAKMCache[iIndex];
			if (oDev.GroupID==64){
				for (var jIndex = 0; jIndex<oDev.binaryInputs.length;jIndex++) {
					if (oDev.binaryInputs[jIndex].type==22) {
						//malfunc
						this.ventilationMalfunctionSensors.setValue(oDev.dSUID);
					}
					if (oDev.binaryInputs[jIndex].type==23) {
						//service
						this.ventilationServiceSensors.setValue(oDev.dSUID);
					}
				}
			}
				
		}
		
		
		this.ventilationOutputDevicesStore.removeAll(); 
		for (var iIndex=0;iIndex<dss.staticDataModel.deviceCache.length;iIndex++) {
			if (this.filterDevice(dss.staticDataModel.deviceCache[iIndex]))
				this.ventilationOutputDevicesStore.add({dsuid:dss.staticDataModel.deviceCache[iIndex].dSUID});
		}	

	},
	saveUBNDWEM: function () {
		var me=this;
		if (this.ventilationSettingBoostEnabler.getValue())
			dss.pushAndQuery('heating-controller.apartment-ventilation',{
				actions : 'setUBNDWEM'
			},'heating-controller.answer',function(eventData) {
				me.saveLevelSettings();
				return true;
			});
		else
			dss.pushAndQuery('heating-controller.apartment-ventilation',{
				actions : 'resetUBNDWEM'
			},'heating-controller.answer',function(eventData) {
				me.saveLevelSettings();
				return true;
			});
	},
	saveLevelSettings: function () {
		var selection=this.ventilationLevelAvaible.getValue();
		var newConfiguration=[];
		switch (selection) {
			case "1":
				newConfiguration=[5];
			break;
			case "2":
				newConfiguration=[5,17];
			break;
			case "3":
				newConfiguration=[5,17,18];
			break;
			case "4":
				newConfiguration=[5,17,18,19];
			break;
		}
		if (this.ventilationSettingBoostEnabler.getValue())
			newConfiguration=newConfiguration.slice(0,newConfiguration.length-1);
		
		newConfiguration.push(36);
		
		if (this.ventilationManual.getValue().ventilationManual)
			newConfiguration.push(0);
		
		dss.ajaxSyncRequest('/json/structure/groupSetConfiguration', {
			zoneID:0,
			groupID:64,
			configuration:Ext.JSON.encode({activeBasicScenes:newConfiguration})
		});
		this.loadPanel();
	},
	saveNormalLevel:function () {
		var me=this;
		var normalLevel=this.ventilationSettingNormalLevel.getValue();
		dss.pushAndQuery('heating-controller.apartment-ventilation',{
			actions : 'setNominalLevel',
			normalLevel : normalLevel
		},'heating-controller.answer',function(eventData) {
			me.loadPanel();
			return true;
		}); 

	},
	saveReduceAbsend: function () {
		var me=this;
		if (this.ventilationSettingAbsentEnabler.checked) {
			var reduceValue=this.ventilationSettingAbsentLevel.getValue();
			dss.pushAndQuery('heating-controller.apartment-ventilation',{
				actions : 'enableAbsentReducment',
				reduceLevel : reduceValue
			},'heating-controller.answer',function(eventData) {
				me.loadPanel();
				return true;
			}); 
		} else {
			dss.pushAndQuery('heating-controller.apartment-ventilation',{
				actions : 'disableAbsentReducment'
			},'heating-controller.answer',function(eventData) {
				me.loadPanel();
				return true;
			}); 
		}
	},
	saveEnableBoost: function () {
		var me=this;
		var maxTime=this.ventilationSettingBoostTime.getValue();
		dss.pushAndQuery('heating-controller.apartment-ventilation',{
			actions : 'setAutoOffBoost',
			maxTime : maxTime
		},'heating-controller.answer',function(eventData) {
			me.loadPanel();
			return true;
		}); 
	},
	setHuminity: function () {
		var me=this;
		if (this.ventilationSettingHumidityExtendedEnabler.checked) {
			var maxHuminity=this.ventilationSettingHumidityExtendedLimit.getValue();
			dss.pushAndQuery('heating-controller.apartment-ventilation',{
				actions : 'setBoostOnHumidity',
				maxHuminity : maxHuminity
			},'heating-controller.answer',function(eventData) {
				me.loadPanel();
				return true;
			}); 
		} else {
			dss.pushAndQuery('heating-controller.apartment-ventilation',{
				actions : 'resetBoostOnHumidity'
			},'heating-controller.answer',function(eventData) {
				me.loadPanel();
				return true;
			}); 
		}
	},
    constructor : function(config) {		
		var me=this;
		this.ventilationManual  = Ext.create('Ext.form.RadioGroup', {
			labelWidth : 295,
			width : 500,
			fieldLabel : _('Ventilation can be turned off'),
			items : [ {
				boxLabel : _('yes'),
				name : 'ventilationManual',
				inputValue : true,
				style : {
					padding : '10px',
					color : "#005138"
				}
			}, {
				boxLabel : _('no'),
				name : 'ventilationManual',
				inputValue : false,
				style : {
					padding : '10px',
					color : "#005138"
				}
			}],
			listeners : {
				change : function(oThis, newValue, oldValue) {
					me.saveLevelSettings();
				}
			}
		});
		
		this.ventilationLevelAvaible = Ext.create('DSS.component.ComboboxControl', {
			labelWidth : 295,
			label : _('Available Levels'),
			storedisplayid:'label',
			storevalueid:'id',
			data : [{id:1,label:_('Level 1 only')},
			        {id:2,label:_('Level 1 and 2')},
					{id:3,label:_('Level 1 to 3')},
					{id:4,label:_('Level 1 to 4')}],
			listeners : {
				change : function(oThis, newValue, oldValue) {
					me.saveLevelSettings();
				}
			}
		});
		this.ventilationLevelAvaible.cboCombo.setWidth(560);		
		this.ventilationSettingNormalLevel = Ext.create('DSS.component.ComboboxControl', {
			width : 175,
			storedisplayid:'label',
			storevalueid:'id',
			data : [{id:1,label:_('Level 1')},
			        {id:2,label:_('Level 2')},
					{id:3,label:_('Level 3')},
					{id:4,label:_('Level 4')}],
			listeners : {
				change : function(oThis, newValue, oldValue) {
					me.saveNormalLevel();
				}
			}
		});
		this.ventilationSettingNormalLevel.cboCombo.setWidth(260);
		this.ventilationSettingAbsentLevel = Ext.create('DSS.component.ComboboxControl', {
			labelWidth : 0,
			width : 175,
			storedisplayid:'label',
			storevalueid:'id',
			data : [{id:1,label:_('Level 1')},
			        {id:2,label:_('Level 2')},
					{id:3,label:_('Level 3')},
					{id:4,label:_('Level 4')}], 
			listeners : {
				change : function(oThis, newValue, oldValue) {
					me.saveReduceAbsend();
				}
			}
		});
		this.ventilationSettingAbsentLevel.cboCombo.setWidth(260);
				
		this.ventilationSettingAbsentEnabler = Ext.create('Ext.form.Checkbox', {
			labelWidth : 230,
			width : 300,
			padding: "3 0 0 0",
			boxLabel : _('Reduce ventilation level when absent'),
			style : {
				padding : '10px',
				color : "#005138"
			},
			listeners : {
				change : function(oThis, newValue) {		
					me.saveReduceAbsend();
				}
			}
		});		
		
		this.ventilationSettingBoostEnabler = Ext.create('Ext.form.Checkbox', {
			labelWidth : 230,
			width : 400,			
			padding: "3 0 0 0",
			boxLabel : _('Always enable boost mode timer for the highest level'),
			colspan:2,
			style : {
				padding : '10px',
				color : "#005138"
			},
			listeners : {
				change : function(oThis, newValue) {
					me.saveUBNDWEM();
				}
			}
		});
		
		this.ventilationSettingHumidityExtendedEnabler = Ext.create('Ext.form.Checkbox', {
			labelWidth : 230,
			width : 300,
			padding: "3 0 0 0",
			boxLabel : _('Set highest ventilation level if humidity exceeds'),
			style : {
				padding : '10px',
				color : "#005138"
			},
			listeners : {
				change : function(oThis, newValue) {
					me.setHuminity();
					if (newValue) {
						me.ventilationSettingHumidityExtendedLimit.setDisabled(false);
					} else {
						me.ventilationSettingHumidityExtendedLimit.setDisabled(true);
					}
						
				}
			}
		});
		
		this.ventilationSettingBoostTime=Ext.create('DSS.component.TimeSpanControl', {            
            width : 175,
            hourMaxValue:23,            
            hideSecond:true,
            listeners : {
            	change: function () {
            		me.saveEnableBoost();
            	}
            }
        });
		this.ventilationSettingBoostTime.suspendEvents();
		this.ventilationSettingBoostTime.setValue(3600);
		this.ventilationSettingBoostTime.resumeEvents();
		
		this.ventilationSettingHumidityExtendedLimit= Ext.create('Ext.form.field.Number', {
            allowBlank : false,
            blankText : _('This field is required'),
            invalidText : _('The value in this field is invalid'),             
            label : '',
            width : 50,
            step : 1,
            value : 0,
            minValue : 0,
            maxValue : 100,
            autoStripChars:true,
            listeners : {
            	change: function () {
            		me.setHuminity();
            	}
            }
        });
		this.ventilationSettingHumidityExtendedLimit.suspendEvents();
		this.ventilationSettingHumidityExtendedLimit.setValue(70);
		this.ventilationSettingHumidityExtendedLimit.resumeEvents();
		

		this.ventilationSettingHumidityExtendedLimitPanel= Ext.create('Ext.panel.Panel', {
            width : 200,
            border:0,
            layout:'hbox',
			items:[this.ventilationSettingHumidityExtendedLimit,{
				width:50,
				xtype:'panel',
				border:0,
				padding: "3 0 0 5",
				html : '<span style="color:#005138;">' + _("% rH") + '</span>'
			}]
		});
		
		this.ventilationOutputDevicesStore = Ext.create('Ext.data.Store', {
			storeId : 'ventilationOutputDevicesStore',
			fields : [ 'dsuid'],
			proxy : {
				type : 'memory',
				reader : {
					type : 'json',
					root : 'items'
				}
			}
		});;
		this.ventilationOutputDevices = Ext.create('Ext.grid.Panel', {
			hideHeaders : true,
			height : 50,
			width : 260,
			autoScroll : true,
			viewConfig : {
				stripeRows : true
			},
			selModel : {
				mode : 'SINGLE'
			},
			store : this.ventilationOutputDevicesStore,
			columns : [ {
				sortable : false,
				hideable : false,
				dataIndex : 'dsuid',
				flex : 1,
				renderer : function(val) {
                    var oDevice = dss.staticDataModel.getDevice(val);
                    var sString = '<table><tr><td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td>';
                    sString += '<td' + (oDevice.present ? '' : ' style="color:grey;"') + '>' + oDevice.name + '</td></tr></table>';
                    return sString;
				}
			} ]
		}); ;		
		
		this.ventilationOutputDevicesPanel= Ext.create('Ext.panel.Panel', {
            width :700,
            border:0,
            layout:'hbox',
			items:[{
				width:300,
				xtype:'panel',
				border:0,
				html : '<span style="color:#005138;">' + _("Output devices") + ':</span>'
			},this.ventilationOutputDevices]
		});
		// binary input 22 / 23
        this.ventilationMalfunctionSensors = Ext.create('Ext.form.field.Display', {
            labelWidth : 300,
            width : 700,
            fieldLabel: _('Malfunction sensor'),
            renderer : function(val) {
                if (val != null && val != "") {
                    var oDevice = dss.staticDataModel.getDevice(val);
                    var sString = '<table><tr><td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td>';
                    sString += '<td' + (oDevice.present ? '' : ' style="color:grey;"') + '>' + oDevice.name + '</td></tr></table>';
                    return sString;
                } else {
                    return _('-');
                }
            }
        });
        this.ventilationServiceSensors = Ext.create('Ext.form.field.Display', {
            labelWidth : 300,
            width : 700,
            fieldLabel: _('Service sensor'),
            renderer : function(val) {
                if (val != null && val != "") {
                    var oDevice = dss.staticDataModel.getDevice(val);
                    var sString = '<table><tr><td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td>';
                    sString += '<td' + (oDevice.present ? '' : ' style="color:grey;"') + '>' + oDevice.name + '</td></tr></table>';
                    return sString;
                } else {
                    return _('-');
                }
            }
        });
		
	    Ext.apply(this, {
	    	border : false,
			flex : 1,
			style : {
				padding : '10px'
			},
			layout : {
				type : 'vbox',
				align : 'left'
			},
			items : [ {
				height : 200,
				width : "100%",
				xtype : 'panel',
				border : false,
				items : [ {
					xtype : 'fieldset',
					style : {
						padding : '10px'
					},
					height : 194,
	                flex : 1,
					title : _('Ventilation System'),
					items : [ 	this.ventilationManual,
		        				this.ventilationLevelAvaible,
		        				this.ventilationOutputDevicesPanel,
		        				this.ventilationMalfunctionSensors,
		        				this.ventilationServiceSensors ]
				} ]
			},{
				height : 400,
				width : "100%",
				xtype : 'panel',
				border : false,
				items : [ {
					xtype : 'fieldset',
					style : {
						padding : '10px',						
					},
					layout: {columns:2,type:'table'},
					height : 394,
	                flex : 1,
					title : _('Ventilation Settings'),
					items : [ 	{	xtype:'panel',
									border : 0,
			            			width : 300,			            			
			            			padding : '0 0 10 5', // top right bottom left
			            			html : '<span style="color:#005138;">' + _("Normal level when being at home:") + '</span>'
			        			},this.ventilationSettingNormalLevel,
			        			{	xtype:'panel',
									border : 0,
			            			width : 300,
			            			margin:'10 0 0 0',
			            			padding : '0 0 10 5', // top right bottom left
			            			html : '<span style="color:#005138;">' + _("Set normal level after boost mode was active for:") + '</span>'
			        			},
		        				this.ventilationSettingBoostTime,
		        				this.ventilationSettingBoostEnabler,			        			
		        				this.ventilationSettingAbsentEnabler,
		        				this.ventilationSettingAbsentLevel,
		        				this.ventilationSettingHumidityExtendedEnabler,
		        				this.ventilationSettingHumidityExtendedLimitPanel ]
				} ]
			}]
		});
		
		this.callParent(arguments);
		this.loadPanel();
    }
});